dojo.provide("itme.ChassisMap.KnownHardwareInfo");

dojo.declare("itme.ChassisMap.KnownHardwareInfo", null, {

  _Nodes: [
      // FIREBIRDS ==========================
      {
        // 4-way PPC Blade - Firebird 4S (Full-wide) - Flex System p460 Compute Node
        Model: "42X",
        MachineType: "7895",
        FRU: "00E0728",
        ImageResource: "ITE_C5440P7",
        Slots: 2
      },
      {
        // 2-way PPC Blade - Firebird 2S(Half-wide) - Flex System p260 Compute Node
        Model: "22X",
        MachineType: "7895",
        FRU: "00E0728",
        ImageResource: "ITE_C5240P7",
        Slots: 1
      },
      // FSMS ==========================
      {
        // 1 way x86 blade - IBM Flex System Manager
        Model: "",//A1Y
        MachineType: "8731",
        FRU: "90Y3193",
        ImageResource: "FSM",
        isFSM: true
      },
      {
        // 1-way x86 Blade - IBM Flex System C3240 M5 Compute Node - IBM Flex System Manager
        Model: "",//01M
        MachineType: "7955",
        ImageResource: "FSM",
        FRU: "90Y3193",
        isFSM: true
      },
      // BLACKTIPS ==========================
      {
        // 2 way x86 blade - IBM Flex System C3240 M5 Compute Node - Flex System x240 Compute Node
        Model: "",//AC1
        MachineType: "8737",
        ImageResource: "ITE_C42x0M4_PEN",
        FRU: "81Y5128",
        Slots: 2
      },
      {
        // 2 way x86 blade - IBM Flex System C3240 M5 Compute Node - Flex System x240 Compute Node
        Model: "",//AC1
        MachineType: "8737",
        ImageResource: "ITE_C42x0M4",
        FRU: "81Y5128",
        Slots: 1
      },
      { // (KESTREL)
        //  - Flex System x220 Compute Node
        Model: "",
        MachineType: "7906",
        ImageResource: "ITE_C42x0M4_PEN",
        FRU: "",
        Slots: 2
      },
      { // (KESTREL)
        //  - Flex System x220 Compute Node
        Model: "",
        MachineType: "7906",
        ImageResource: "ITE_C42x0M4",
        FRU: "",
        Slots: 1
      },
      {
        //  - Flex System x240 Compute Node
        Model: "",
        MachineType: "7863",
        ImageResource: "ITE_C42x0M4",
        FRU: ""
      },
      { // (CONGO)
        //  - Flex System x440 Compute Node
        Model: "",
        MachineType: "7917",
        ImageResource: "ITE_C4440M4",
        FRU: ""
      },
      // STORAGE ==========================
      {
        //  - Flex System V7000 Storage Node
        Model: "A49",
        MachineType: "4939",
        ImageResource: "STRW_493949", // ?? need to determine between : SRC Controller model 4939-49 & SDE Expansion model 4939-29
        FRU: ""
      },
      {
        //  - Flex System V7000 Storage Node
        Model: "A29",
        MachineType: "4939",
        ImageResource: "STRW_493929", // ?? need to determine between : SRC Controller model 4939-49 & SDE Expansion model 4939-29
        FRU: ""
      },
      // OTHER ==========================
      { // (CMM)
        // - IBM Flex System Chassis Management Module
        Model: "",//68Y
        MachineType: "7030",
        ImageResource: "CMM",
        FRU: ""
      },
      { // (PME)
        // - IBM Flex System PCI Expansion Unit
        Model: "",//81Y
        MachineType: "8983",
        ImageResource: "PME",
        FRU: ""
      },
      // SWITCHES ==========================
      {
        // COMPASS
        // IBM Flex System EN4093 10Gb Virtual Fabric Scalable Switch - 10Gb BNT Switch Module for Accipiter chassis
        Model: "49Y",
        MachineType: "4270",
        ImageResource: "SwitchEN4093",
        FRU: "",
        ProductId: 322
      },
      { // - IBM Flex System EN4093 10Gb Virtual Fabric Scalable Switch-Upgrade 1
        Model: "49Y",
        MachineType: "4798",
        ImageResource: "SwitchEN4093",
        FRU: "",
        ProductId: 322
      },
      { // - IBM Flex System EN4093 10Gb Virtual Fabric Scalable Switch-Upgrade 2
        Model: "88Y",
        MachineType: "6037",
        ImageResource: "SwitchEN4093",
        FRU: "",
        ProductId: 322
      },
      { // POLLUX
        // IBM Flex System EN2092 1Gb Ethernet Scalable Switch - BL5221 BNT Ethernet Scalable Switch
        Model: "49Y",
        MachineType: "4294",
        ImageResource: "SwitchEN2092",
        FRU: "",
        ProductId: 347
      },
      { //  - IBM Flex System EN2092 1Gb Ethernet Scalable Switch-Upgrade 1
        Model: "90Y",
        MachineType: "3562",
        ImageResource: "SwitchEN2092",
        FRU: "",
        ProductId: 347
      },
      { //  - IBM Flex System EN2092 1Gb Ethernet Scalable Switch-10Gb Uplinks
        Model: "49Y",
        MachineType: "4298",
        ImageResource: "SwitchEN2092",
        FRU: "",
        ProductId: 347
      },
      { // PROCYON
        // IBM Flex System EN4091 10Gb Ethernet Pass-thru - Procyon switch for Accipiter

        Model: "88Y",
        MachineType: "6043",
        ImageResource: "SwitchEN4091",
        FRU: "",
        ProductId: 369
      },
      { // SAMURI FABRIC
        // IBM Flex System FC3171 8Gb SAN Switch - Switch Qlogic 8Gb 20-port ScSE – Samurai

        Model: "69Y",
        MachineType: "1930",
        ImageResource: "SwitchFC3171",
        FRU: "",
        ProductId: 327
      },
      { //  - IBM Flex System FC3171 8Gb SAN Pass-thru - IPM Qlogic 8Gb 20-port ScSE – Samurai
        Model: "69Y",
        MachineType: "1934",
        ImageResource: "SwitchFC3171",
        FRU: "",
        ProductId: 348
      },
      { // PHAROS
        // IBM Flex System FC5022 24-port 16Gb SAN Scalable Switch - IBM Flex System FC5022 16Gb SAN Scalable Switch - Brocade 16Gb ScSE (Pharos)
        Model: "88Y",
        MachineType: "6374",
        ImageResource: "SwitchFC5022",
        FRU: "",
        ProductId: 329
      },
      { // IBM Flex System FC5022 24-port 16Gb ESB SAN Scalable Switch - IBM Flex System FC5022 24-port 16Gb ESB SAN Scalable Switch
        Model: "90Y",
        MachineType: "9356",
        ImageResource: "SwitchFC5022",
        FRU: "",
        ProductId: 329
      },
      { // SUBMARINE
        // IBM Flex System IB6131 Infiniband Switch - QDR/FDR IB switch. Code name: Submarine 36 port Mellanox Infiniband Switch
        Model: "90Y",
        MachineType: "3450",
        ImageResource: "SwitchIB6131",
        FRU: "",
        ProductId: 365
      },
      { // IBM Flex System IB6131 Infiniband Switch - IBM Flex System IB6131 Infiniband Switch-FDR Upgrade
        Model: "90Y",
        MachineType: "3462",
        ImageResource: "SwitchIB6131",
        FRU: "",
        ProductId: 365
      },
      // WILDCAT - IBM Flex System EN4054 4-port 10Gb Ethernet Adapter - ?
      //         - IBM Flex System CN4054 10Gb Virtual Fabric Adapter - 90Y3554
      //         - IBM Flex System CN4054 Virtual Fabric Adapter-SW Upgrade - 90Y3558
      // MUSTANG - IBM Flex System EN2024 4-port 1Gb Ethernet Adapter - 49Y7900
      // NINJA - IBM Flex System FC3172 2-port 8Gb FC Adapter - 69Y1938
      { // CHINOOK
        //  - IBM Flex System FC5022 2-port 16Gb FC Adapter
        Model: "88Y",
        MachineType: "6370",
        ImageResource: "SwitchFC5022",
        FRU: "",
        ProductId: 9
      }
      // MALAYA - IBM Flex System IB6132 2-port QDR Infiniband Adapter - ?
      //        - IBM Flex System IB6132 2-port FDR Infiniband Adapter - 90Y3454
      //        - IBM Flex System EN4132 2-port 10Gb Ethernet Adapter - 90Y3466
      // RHEA - IBM Flex System FC3052 2-port 8Gb FC Adapter - 95Y2375

    ],

  constructor: function(kwArgs){},

  getImageResourceForModelAndType: function(model, machineType, numSlots) {
    for (var i = 0; i < this._Nodes.length; i++)
    {
      if ( machineType == this._Nodes[i].MachineType ) {
        if ( this._Nodes[i].Slots && this._Nodes[i].Slots != numSlots)
        //if ( this._Nodes[i].Model != "" && this._Nodes[i].Model != model )
          continue;

        return this._Nodes[i].ImageResource;
      }
    }
  },

  getImageResourceForProductId: function(productId) {
    if (!productId)
      return;

    for (var i = 0; i < this._Nodes.length; i++)
    {
      if ( this._Nodes[i].ProductId && (productId == this._Nodes[i].ProductId) )
        return this._Nodes[i].ImageResource;
    }
  },

  isFSM: function(machineType) {
    for (var i = 0; i < this._Nodes.length; i++)
    {
      if ( machineType == this._Nodes[i].MachineType ) {
        if ( this._Nodes[i].isFSM && this._Nodes[i].isFSM === true)
          return true;
      }
    }
    return false;
  }

});
