/*
	Copyright (c) 2004-2010, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource["ibm.tivoli.tip.charts.dijit.ChartPager"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["ibm.tivoli.tip.charts.dijit.ChartPager"] = true;
/******************************************************* {COPYRIGHT-TOP-OCO} ***
 * Licensed Materials - Property of IBM
 *
 * (C) Copyright IBM Corp. 2009 All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication, or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************* {COPYRIGHT-END-OCO} ***/

dojo.provide("ibm.tivoli.tip.charts.dijit.ChartPager");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.Toolbar");
dojo.require("dijit.form.Button");

// NLS
dojo.requireLocalization("ibm.tivoli.tip.dijit", "resources", null, "ROOT,ar,cs,da,de,en,en-us,es,fi,fr,he,hr,hu,it,iw,ja,ko,nb,nl,no,pl,pt-br,ru,sl,sv,tr,zh-cn,zh-tw");

dojo.declare("ibm.tivoli.tip.charts.dijit.ChartPager",
              [ dijit._Widget, dijit._Templated],
{
	widgetsInTemplate: true,
	templateString:"<table class=\"tip-table-footer-border\" cellspacing=\"0\" cellpadding=\"0\" border=\"0\">\n\t<tbody>\n\t\t<tr class=\"tip-table-footer\" dir=\"ltr\">\n\t\t\t<td class=\"tip-table-footer-data\" nowrap=\"nowrap\" valign=\"middle\" align=\"right\"> \n\t\t\t\t<div dojoAttachPoint=\"pageLabel\" class=\"footerLabel\"></div>\n\t\t\t</td>\n\t\t\t<td class=\"tip-table-footer-data\" nowrap=\"nowrap\" valign=\"middle\" align=\"left\"> \t\t\t\t\n\t\t\t\t<div type=\"text\" dojoType=\"dijit.form.NumberSpinner\" scrollOnFocus=\"true\" selectOnClick=\"true\" intermediateChanges=\"true\" dojoAttachPoint=\"page_number\" dojoAttachEvent=\"onChange:jumpPage\" style=\"width:50px;\" required=\"true\" value=\"1\">\n                </div>\n\t\t\t</td>\n\t\t\t<td class=\"tip-table-footer-data\" nowrap=\"nowrap\" valign=\"middle\" align=\"left\"> \n\t\t\t\t<div dojoAttachPoint=\"totalPage\" class=\"footerLabel\"></div>\n\t\t\t</td>\n\t\t\t<td class=\"tip-table-footer-data\" width=\"100%\" nowrap=\"nowrap\" valign=\"middle\" align=\"right\"> \n\t\t\t\t<div dojoAttachPoint=\"rowsShowRate\" class=\"footerLabel\"></div>\n\t\t\t</td>\n\t\t</tr>  \n\t</tbody>\n</table>\n",
	chartFetcher: null,
	totalRows: null,
	
	constructor: function () {
		this.currentPage = 0;
		this.resources_ = dojo.i18n.getLocalization("ibm.tivoli.tip.dijit", "resources");    
	},
	postCreate: function () {
		this.totalRows = this.chartFetcher.getTotalRows();
		this.updateFooter();
		this.configureTextBox();
	},
	configureTextBox: function(){
		var consts = {};
		consts.min = 1;
		consts.max = this.getMaxPages();
		this.page_number.attr('constraints', consts);
		//this.page_number.attr('value', 1);
	},
	removeCharts: function() {
		if(this.chartDef.type =="Pie"){
			var div = dojo.byId (this.chartBuilder.id + "chart0");			
			div.removeChild(div.firstChild);			
			this.chartBuilder.chart = null;
			for(var i=0; i< this.chartBuilder.charts.length;i++){
				this.chartBuilder.charts[i].destroy();
			}
		}
	},
	jumpPage: function (event) {
		var pageNumber = this.page_number.attr('value');
		if (!isNaN(pageNumber)){
			if(pageNumber > this.getMaxPages()){
				this.currentPage = this.getMaxPages()-1;
			}else if(pageNumber<=0){
				this.currentPage = 0;
			}else{
				this.removeCharts();
				this.currentPage = pageNumber - 1;
				var start = this.currentPage * this.chartFetcher.rowsPerPage;
				this.chartFetcher.fetchData (start, this.chartFetcher.rowsPerPage);
				this.updateFooter();
			}
		}
	},
	updatePageNumber: function () {
		this.page_number.attr('value', this.currentPage+1);
	},
	getMaxPages: function () {
		
		
		return (Math.ceil (this.totalRows / this.chartFetcher.rowsPerPage));
	},
	getCurrentPage: function () {
		return (this.currentPage);
	},
	updateFooter: function() {
		//this.setInfoAreaHTML( dojo.string.substitute( this.resources_.PAGE_X_OF_Y, { 0: this.currentPage + 1, 1: this.getMaxPages() } ) );
		this.setPageLabelHTML( dojo.string.substitute( this.resources_.PAGE_LABEL ) );		
		this.setTotalPageHTML( dojo.string.substitute( this.resources_.PAGE_OF_Y, { 0: this.getMaxPages() } ) );
		this.setRowsShowRateHTML( dojo.string.substitute( this.resources_.ROW_SHOW_RATE, { 0: this.chartFetcher.rowsPerPage, 1: this.totalRows }) );
	},
	setPageLabelHTML: function (html) {
		this.pageLabel.innerHTML = html;
	},
	setTotalPageHTML: function (html) {
		this.totalPage.innerHTML = html;
	},
	setRowsShowRateHTML: function (html) {
		this.rowsShowRate.innerHTML = html;
	},
	setInfoAreaHTML: function (html) {
		this.infoArea.innerHTML = html;
	},
	onRefresh: function () {
		var start = this.currentPage * this.chartFetcher.rowsPerPage;
		this.chartFetcher.fetchData (start, this.chartFetcher.rowsPerPage);
	}
});

}
