/*
	Copyright (c) 2004-2010, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource["ibm.tivoli.tip.charts.dijit.ChartTitle"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["ibm.tivoli.tip.charts.dijit.ChartTitle"] = true;
/******************************************************* {COPYRIGHT-TOP-OCO} ***
 * Licensed Materials - Property of IBM
 *
 * (C) Copyright IBM Corp. 2009 All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication, or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************* {COPYRIGHT-END-OCO} ***/

dojo.provide("ibm.tivoli.tip.charts.dijit.ChartTitle");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

// NLS
dojo.requireLocalization("ibm.tivoli.tip.dijit", "resources", null, "ROOT,ar,cs,da,de,en,en-us,es,fi,fr,he,hr,hu,it,iw,ja,ko,nb,nl,no,pl,pt-br,ru,sl,sv,tr,zh-cn,zh-tw");

dojo.declare("ibm.tivoli.tip.charts.dijit.ChartTitle",
              [ dijit._Widget, dijit._Templated],
{
	widgetsInTemplate: true,
	templateString:"<table cellspacing=\"0\" cellpadding=\"0\" border=\"0\" align=\"center\">\n\t<tbody>\n\t\t<tr>\n\t\t\t<td> \n\t\t\t\t<div class=\"chartIcon\" id=\"${id}icon\">\n\t\t\t\t</div>\n\t\t\t</td>\t\t\t\n\t\t\t<td> \n\t\t\t\t<div class=\"chartTitle\" id=\"${id}text\">\n\t\t\t\t</div>\n\t\t\t</td>\t\t\t\n\t\t</tr>  \n\t</tbody>\n</table>\n",
	title: null,
	namespace: "1234",
	chartid: null,
	
	constructor: function () {
	    this.resources_ = dojo.i18n.getLocalization("ibm.tivoli.tip.dijit", "resources");    
	},
	postCreate: function () {
		if (this.title !== null) {
			this.setTitle (this.title);
		}
		
		this.makeTitleContextMenu();
	},
	setTitle: function (title) {
		var textDiv = dojo.byId (this.id + "text");
		
		var titleHTML = "<span>" + title + "</span>";
		textDiv.innerHTML = titleHTML;
	},
	makeTitleContextMenu: function () {
		console.log ("enter makeTitleContextMenu");	
		var provider = new ibm.tivoli.tip.dijit.TIPContextMenuProvider(
					{ iscPortletNamespace: this.iscPortletNamespace,
					  getMenuItemsCallback: dojo.hitch (this, this.getMenuItems)
					});
		console.log ("after make provider");

		var menu = new ibm.tivoli.tip.dijit.TIPContextMenuProxy(
			{cmProvider: provider, 
			 targetNodeIds: [this.id + "icon"],
			 getContextCallback: dojo.hitch (this, this.getSelectedData)
			});
		console.log ("after create context menu");
	},
	getSelectedData: function () {
	},
	getMenuItems: function () {
		var menuItems = [
			     			{ id: this.namespace + "RefreshChartMenuItem", label: this.resources_.REFRESH, iconClass: "refreshIcon", launchType: "JavaScript", uri: "tipdijit.byId ('" + this.chartid + "').onRefresh();", enabled: true },
			     			{ id: this.namespace + "PreferencesMenuItem", label: this.resources_.PREFERENCES, iconClass: "propertiesIcon", launchType: "JavaScript", uri: "tipdijit.byId ('" + this.chartid + "').onPreferences();", enabled: true }
			     		];		
		return (menuItems);
	}
});

}
