/*
	Copyright (c) 2004-2010, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource["ibm.tivoli.tip.dijit.ExpandableContainer"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["ibm.tivoli.tip.dijit.ExpandableContainer"] = true;

dojo.provide("ibm.tivoli.tip.dijit.ExpandableContainer");
dojo.require("dojo.fx");
dojo.require("dijit._Templated");
dojo.require("dijit._Widget");
dojo.require("dijit.layout.BorderContainer");
dojo.require("dijit.layout.ContentPane");
dojo.declare("ibm.tivoli.tip.dijit.ExpandableContainer",[dijit._Widget,dijit._Templated],{
	scope:(dojo._scopeName||"dojo"),
	templateString:"<div dojoAttachPoint=\"rootpane\"  gutters=\"false\" >\n \t  <div class=\"\"  region=\"top\" >\n\t       <div dojoAttachPoint=\"toggleIcon\"></div>\n\t\t \t<h1 class=\"section h1\" dojoAttachPoint=\"titleNode\"></h1>\n\t\t\t\n\t  </div> \n\t \n\t  <div dojoAttachPoint=\"contentPane\"  region=\"center\">\n\t\t<div dojoAttachPoint=\"containerNode\"></div>\n\t\t\n\t  </div>\n</div>\n",
	widgetsInTemplate:true,
	expanded:true,
	title:"",
	postCreate:function(){
		this.inherited(arguments);
		this.titleNode.setAttribute("tabindex","0");  
		this.titleNode.setAttribute("role","region");  
		this.titleNode.setAttribute("aria-label","Expandable/Collapsable section");  
		this.containerNode.setAttribute("tabindex","0"); 
		this.connect(this.toggleIcon,"onclick",this._toggleContent);
		this.connect(this.titleNode,"onclick",this._toggleContent);
		this.connect(this.titleNode,"onkeydown",this._toggleContentKeyboard);
		this.setTitle(this.title);
		if(this.expanded==false){
		 this._collapse();
		 this.titleNode.className="section iconclose";
		 }
		 else {
		   this.titleNode.className="section iconopen";
		 }
		 this.titleNode.setAttribute("aria-expanded",this.expanded); 
		 this.rootpane = new dijit.layout.BorderContainer();
		 this.contentPane = new dijit.layout.BorderContainer();
	 },	 
	 addWidget: function(widget) {
	   this.rootpane.addChild(widget);
	 },
	 setTitle:function(_1){
	 this.titleNode.innerHTML=this.title=_1;
	 },
	 getTitle:function(){
	 return this.title;
	 },
	 expand:function(){
	    console.info("expand");
		 if(this.expanded==false){
		 this._expand();
		}
	 },
	 _expand:function(){
		 this.expanded=true;
		this.titleNode.className="section iconopen";
		 dojo.fx.wipeIn({
		 node:this.containerNode,duration:500}).play();
	 },
	 collapse:function(){
	      console.info("collapse");
		 if(this.expanded==true){
		 this._collpase();
		 }
	 },
	 _collapse:function(){
		 this.expanded=false;
		 this.titleNode.className="section iconclose";
		 dojo.fx.wipeOut({node:this.containerNode,duration:500}).play();
	 },
	 _toggleContent:function(){
		this.expanded?this._collapse():this._expand();
		this.titleNode.setAttribute("aria-expanded",this.expanded);  
	 },
	 _toggleContentKeyboard:function(event){
		if(event.keyCode == 9 || event.keyCode == 16 || event.keyCode == 18){
			return;
		}
		this._toggleContent();
	 }
 });

}
