/*
	Copyright (c) 2004-2010, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource["ibm.tivoli.tip.dijit.TIPTableOptionsDialog"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["ibm.tivoli.tip.dijit.TIPTableOptionsDialog"] = true;
/******************************************************* {COPYRIGHT-TOP-OCO} ***
 * Licensed Materials - Property of IBM
 *
 * (C) Copyright IBM Corp. 2009 All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication, or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************* {COPYRIGHT-END-OCO} ***/
/*******************************************************************************
 * CMVC Location: %W%
 * Version:       %I%
 * Last Modified: %G%
 *******************************************************************************/

dojo.provide("ibm.tivoli.tip.dijit.TIPTableOptionsDialog");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.Dialog");
dojo.require("dijit.Toolbar");
dojo.require("dijit.form.Form");
dojo.require("dijit.form.Button");
dojo.require("dijit.form.CheckBox");
dojo.require("dijit.layout.TabContainer");
dojo.require("dijit._Container");
dojo.require("ibm.tivoli.tip.dijit.TIPButton");
dojo.require("ibm.tivoli.tip.dijit.TIPTableOptions");

// NLS
dojo.requireLocalization("ibm.tivoli.tip.dijit", "resources", null, "ROOT,ar,cs,da,de,en,en-us,es,fi,fr,he,hr,hu,it,iw,ja,ko,nb,nl,no,pl,pt-br,ru,sl,sv,tr,zh-cn,zh-tw");


// define the widget class
dojo.declare (
	"ibm.tivoli.tip.dijit.TIPTableOptionsDialog", 
    [ dijit._Widget, dijit._Templated ],
{
	templateString:"<div>\n  <div dojoType=\"dijit.Dialog\" dojoAttachPoint=\"dialog\"\ttitle=\"${resources_.TABLE_PREFERENCES}\"\tstyle=\"display:none;\" >\n\n\t\t<div id=\"${id}tabs\" dojoType=\"dijit.layout.TabContainer\" class=\"dialog\" style=\"width: 550px; height: 350px;\" >\n\t\t\t<div dojoType=\"dijit.layout.ContentPane\" selected=\"true\" title=\"${resources_.COLUMNS}\" \n\t\t\t \tclass=\"dialog\" style=\"padding: 15px\">\n\t\t\t\t<div style=\"width: 480px; height: 280px; overflow: auto\" >\n\t\t\t\t \t${resources_.COLUMNS_VISIBLE}\n\t\t\t\t \t<br/><br/>\n                    <button  iconClass=\"selectAllIcon\"  dojoType=\"ibm.tivoli.tip.dijit.TIPButton\"      dojoAttachEvent=\"onClick:onSelectAll\" title=\"${resources_.SELECT_ALL}\" ></button> \n                    <button  iconClass=\"deselectAllIcon\"   dojoType=\"ibm.tivoli.tip.dijit.TIPButton\"      dojoAttachEvent=\"onClick:onDeselectAll\" title=\"${resources_.DESELECT_ALL}\" ></button>\n\t\t\t\t \t<div id=\"${id}columnsVisibleDivContainer\">\n\t\t\t\t \t</div>\n\t\t\t\t </div>\n\t\t\t</div>\n\t\t</div>\t  \n\n\t\t<div dojoType=\"dijit.Toolbar\" style=\"padding: 0px\">\n\t\t\t<button  \n\t\t\t       value=\"${resources_.OK}\"\n\t\t\t       dojoType=\"ibm.tivoli.tip.dijit.TIPButton\"\n\t\t\t       dojoAttachEvent=\"onClick:onOK\" \n\t\t\t>${resources_.OK}</button>\n\t\t\t<button  \n\t\t\t\t   dojoType=\"ibm.tivoli.tip.dijit.TIPButton\"\n\t\t\t\t   dojoAttachPoint=\"cancelButton\"\n\t\t\t\t   dojoAttachEvent=\"onClick:onCancel\"\n\t\t\t       value=\"${resources_.CANCEL}\"\n\t \t\t>${resources_.CANCEL}</button>\n\t \t</div>\n\n  </div>\n</div>\n",
	widgetsInTemplate: true,
	table: null,
	optionsWidget_: null,
	global: null,

	constructor: function() {
		// summary: A reusable widget for displaying a dynamic set of parameters to be 
		//  filled in at runtime.
		console.log ("enter TIPTableOptionsDialog.constructor");
	    this.resources_ = dojo.i18n.getLocalization("ibm.tivoli.tip.dijit", "resources");
	},
	postCreate: function() { 
		this.inherited ("postCreate", arguments);
		console.info ("enter TIPTableOptions:postCreate");

		this.optionsWidget_=new ibm.tivoli.tip.dijit.TIPTableOptions (
			{
				table: this.table,
				global: this.global
			}, 
			dojo.byId(this.id + "columnsVisibleDivContainer")
		);
		this.optionsWidget_.startup();
		
	},
	//add 2009/07/07 by chujing for  function select all
	onSelectAll: function(){
		
	this.optionsWidget_.onSelectAll();
	},
	//add 2009/07/07 by chujing for  function deselect all
	onDeselectAll: function(){
		
	this.optionsWidget_.onDeselectAll();
	},
	
	onOK: function () {
		// TODO: persist changes
		console.log ("enter TIPOptionsDialog.onOK");
		this.optionsWidget_.onSave();
		this.hide();
	},
	onCancel: function () {
		console.log ("enter TIPOptionsDialog.onCancel");
		this.hide();
		// TODO: revert changes
	},
	show: function () {
		this.dialog.show();
		dijit.byId (this.id + "tabs").resize();
	},
	hide: function () {
		this.dialog.hide();
		setTimeout (dojo.hitch (this, this.kill), 100);
	},
	kill: function () {
		var id = this.id;
		this.destroyRecursive();
		dijit.registry.remove (id);
	},
	getTableOptions: function () {
		return (this.optionsWidget_);
	}
});



}
