/*
	Copyright (c) 2004-2010, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource["ibm.tivoli.tip.dijit.TIPTableToolbar"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["ibm.tivoli.tip.dijit.TIPTableToolbar"] = true;
/******************************************************* {COPYRIGHT-TOP-OCO} ***
 * Licensed Materials - Property of IBM
 *
 * 5724-C51
 *
 * (C) Copyright IBM Corp. 2007 All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication, or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************* {COPYRIGHT-END-OCO} ***/
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.Toolbar");

dojo.require("ibm.tivoli.tip.dijit.TIPTableSearchField");

dojo.provide("ibm.tivoli.tip.dijit.TIPTableToolbar");

/******************************************************************************
* A dijit.Toolbar and a TIPTableSearchField combined into one.
*
* Authors: Joseph Firebaugh
******************************************************************************/
dojo.declare("ibm.tivoli.tip.dijit.TIPTableToolbar",
            [ dijit._Widget, dijit._Templated ],
{
  widgetsInTemplate: true,
   shownub : true,
   nubhover :true,
   nub :null,
   stateMinimized:false,
  templateString:"<div>\n\t<div >\n\t\t<table   border=\"0\" cellpadding=\"0\" cellspacing=\"0\" class=\"tableToolbar\"   dojoAttachPoint=\"toolbarBody\">\n\t\t<tbody>\n\t\t<tr  id=\"${id}toolbarTR\" dojoAttachPoint=\"toolbarDom\" >\n\t\t\t<td   class=\"TIPTableToolbarArea\" width=\"100%\" style=\"height:auto\">\n\t\t\t<div style=\"position:relative\" dojoAttachPoint=\"nubArea\" >\n\t\t\t<div id=\"${id}toolbar\" dojoType=\"dijit.Toolbar\" dojoAttachPoint=\"toolbar\"  class=\"tableToolbarArea\" ></div>\n\t\t\t</div>\n\t\t\t</td>\n\t\t\t<td id =\"${id}searchbar\" class=\"TIPTableSearchFieldArea\" height=\"auto\">\n\t\t\t<div dojoType=\"ibm.tivoli.tip.dijit.TIPTableSearchField\" dojoAttachPoint=\"searchField\"></div>\n\t\t\t</td>\n\t\t</tr>\n\t\t\n\t\t</tbody>\n\t\t\t\n\t\t</table>\n\t\t\n\t\t\n\t    </div>\n\t\t\n</div>\n",
  
  getToolbar: function()
  {
    return this.toolbar;
  },
   postCreate : function(){
    if(this.shownub == true) {
	console.warn("postCreate nub");
	var div = document.createElement("div");
		
	this.nub=div;
	div.setAttribute("tabIndex","0");
	dojo.addClass(div,"nubOpen");
	this.resetNubPos();
	dojo.style(div,"position","absolute");
	dojo.style(div,"bottom","-1px");
	dojo.style(div,"height","9px");
	dojo.style(div,"align","center");
	// fix for accessibility, setting aria attributes
	div.setAttribute("role","button");
	div.setAttribute("title","toggle toolbar");
	div.setAttribute("wairole","button");
	div.setAttribute("aria-labelledby","toggle toolbar");
	 if(this.nubhover ==true){
		dojo.style(div,"display","none");
		dojo.connect(this.toolbarDom,'onmouseover',this,this._mouseover);
		dojo.connect(this.toolbarDom,'mouseout',this,this._mouseout);
	  }	
	this.nubArea.appendChild(div);
	}
  },
  resetNubPos : function(){
	if (this.shownub == true) {   
		var coords = dojo.coords(this.toolbarBody);
		//var centerx =  coords.x + (coords.w/2);
		var centerx = coords.w/2;
		dojo.style(this.nub,"left",centerx+"px");
	}
  },
  _mouseover:function() {
   
   if(this.stateMinimized==false){
   dojo.style(this.nub,"display","block");
   }
  },
  _mouseout :function(){
  
   if(this.stateMinimized==false){
   dojo.style(this.nub,"display","none");
  }
  },
  destroy: function()
  {
	this.inherited( "destroy", arguments );
	if(this.searchField){
		this.searchField.destroy();
	}
	if(this.toolbar){
		this.toolbar.destroy();
	}  	
  }    
});

}
