/*
	Copyright (c) 2004-2010, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource["ibm.tivoli.tip.dijit.TivNotebook"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["ibm.tivoli.tip.dijit.TivNotebook"] = true;
console.warn("'ibm.tivoli.tip.dijit.TivNotebook' is deprecated, use 'dojoe.notebook.Notebook'(TED) instead.");
dojo.provide("ibm.tivoli.tip.dijit.TivNotebook");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.layout.TabContainer");
dojo.require("dojo.i18n");
dojo.requireLocalization("ibm.tivoli.tip.dijit", "resources", null, "ROOT,ar,cs,da,de,en,en-us,es,fi,fr,he,hr,hu,it,iw,ja,ko,nb,nl,no,pl,pt-br,ru,sl,sv,tr,zh-cn,zh-tw");
dojo.require("ibm.tivoli.tip.dijit.TivPage");

/**
 * Inherit from TivPageContainer which contains the common functions of both
 * the notebook and wizard.
 */
dojo.require("ibm.tivoli.tip.dijit.TivPageContainer");

/*
 * Creating a TivNotebook in markup
 * <div id="note" dojoType="ibm.tivoli.tip.dijit.TivNotebook">
 *    <div dojoType="ibm.tivoli.tip.dijit.tests.tivpages.Welcome"></div>
 *    <div dojoType="ibm.tivoli.tip.dijit.tests.tivpages.BaseWidget"></div>
 *    <div dojoType="ibm.tivoli.tip.dijit.tests.tivpages.General"></div>
 *    <div dojoType="ibm.tivoli.tip.dijit.tests.tivpages.Security"></div>
 *    <div dojoType="ibm.tivoli.tip.dijit.tests.tivpages.Summary" ></div>
 *  </div> 
 * 
 * Events:
 *  OnPageSelected: when a page is made active
 *  AfterPageSelected: after a page has been made active
 *  OnOK: when the OK button is clicked
 *  OnApply: when the Apply button is clicked
 *  OnCancel: when the Cancel button is clicked
 */
dojo.declare("ibm.tivoli.tip.dijit.TivNotebook", 
            [dijit._Widget, dijit._Templated, ibm.tivoli.tip.dijit.TivPageContainer],
{
  widgetsInTemplate: true,
  templatePath: "",

  mode: "n",               // notebook
  applyLabel: "",
  okLabel: "",  
  cancelLabel: "",  
  _origApply: null,
  
  constructor: function()
  {
    this._origApply = this.OnApply;
  },

  postMixInProperties: function()
  {
    console.log("TivNotebook.postMixInProperties");    
    if (this.nested)
      this.templateString="<div class=\"tiv-notebook\">\n  <div dojoType=\"dijit.layout.BorderContainer\" design=\"headline\" gutters=\"false\" class=\"tiv-notebook-outer\" dojoAttachPoint=\"_outerContainer\">\n    <div dojoType=\"dijit.layout.BorderContainer\" gutters=\"false\" liveSplitters=\"false\" design=\"sidebar\" region=\"center\" style=\"width:100%;height:100%;\" dojoAttachPoint=\"_borderArea\">\n      <div dojoType=\"dijit.layout.ContentPane\" region=\"leading\" splitter=\"false\" class=\"tiv-notebook-toc\" dojoAttachPoint=\"_tocArea\">\n        <ol dojoAttachPoint=\"_toc\"></ol>\n      </div>\n      <div dojoType=\"dijit.layout.TabContainer\" region=\"center\" splitter=\"false\" dojoAttachPoint=\"_pageContainer\" nested=\"true\" class=\"tiv-notebook-work-area\">\n        <div dojoAttachPoint=\"containerNode\"></div>              \n      </div>\n    </div>\n    <div dojoType=\"dijit.layout.ContentPane\" region=\"bottom\" splitter=\"false\" class=\"tiv-notebook-footer\" dojoAttachPoint=\"_buttonArea\">\n      <div class=\"tiv-notebook-buttons\" dojoAttachPoint=\"_buttons\"> \n        <button dojoType=\"dijit.form.Button\" dojoAttachEvent=\"onClick:_onClickFinish\" dojoAttachPoint=\"_finishButton\">${okLabel}</button>\n        <button dojoType=\"dijit.form.Button\" dojoAttachEvent=\"onClick:_onClickApply\" dojoAttachPoint=\"_applyButton\">${applyLabel}</button>\n        <button dojoType=\"dijit.form.Button\" dojoAttachEvent=\"onClick:_onClickCancel\" dojoAttachPoint=\"_cancelButton\">${cancelLabel}</button>\n      </div>        \n    </div>\n  </div>\n</div>\n";
    else
      this.templateString="<div class=\"tiv-notebook\">\n  <div dojoType=\"dijit.layout.BorderContainer\" design=\"headline\" gutters=\"false\" class=\"tiv-notebook-outer\" dojoAttachPoint=\"_outerContainer\">\n    <div dojoType=\"dijit.layout.BorderContainer\" gutters=\"false\" liveSplitters=\"false\" design=\"sidebar\" region=\"center\" style=\"width:100%;height:100%;\" dojoAttachPoint=\"_borderArea\">\n      <div dojoType=\"dijit.layout.ContentPane\" region=\"leading\" splitter=\"false\" class=\"tiv-notebook-toc\" dojoAttachPoint=\"_tocArea\">\n        <ol dojoAttachPoint=\"_toc\"></ol>\n      </div>\n      <div dojoType=\"dijit.layout.TabContainer\" region=\"center\" splitter=\"false\" dojoAttachPoint=\"_pageContainer\" class=\"tiv-notebook-work-area\">\n        <form id=\"${id}_form\" dojoAttachPoint=\"containerNode\" action=\"${action}\" method=\"${method}\"></form>              \n      </div>\n    </div>\n    <div dojoType=\"dijit.layout.ContentPane\" region=\"bottom\" splitter=\"false\" class=\"tiv-notebook-footer\" dojoAttachPoint=\"_buttonArea\">\n      <div class=\"tiv-notebook-buttons\" dojoAttachPoint=\"_buttons\"> \n        <button dojoType=\"dijit.form.Button\" dojoAttachEvent=\"onClick:_onClickFinish\" dojoAttachPoint=\"_finishButton\">${okLabel}</button>\n        <button dojoType=\"dijit.form.Button\" dojoAttachEvent=\"onClick:_onClickApply\" dojoAttachPoint=\"_applyButton\">${applyLabel}</button>\n        <button dojoType=\"dijit.form.Button\" dojoAttachEvent=\"onClick:_onClickCancel\" dojoAttachPoint=\"_cancelButton\">${cancelLabel}</button>\n      </div>        \n    </div>\n  </div>\n</div>\n";
    console.log("templatePath is " + this.templatePath);

    var string_table = dojo.i18n.getLocalization("ibm.tivoli.tip.dijit", "resources");
    this.applyLabel = string_table.APPLY;
    this.okLabel = string_table.OK;
    this.cancelLabel = string_table.CANCEL;
    this.inherited(arguments);
  },
  
  buildRendering: function()
  {
    console.log("TivNotebook.buildRendering");        

    this.inherited(arguments);

    // if horizontal layout...
    if ('h' === this.layout) {
      // remove toc area and use tab container's tab strip
      this._borderArea.removeChild(this._tocArea);
      this._toc = null;
    }
    else {
      // hide tab container's tab strip and use toc area
      this._pageContainer._setClassAttr("tiv-notebook-tabstrip-hidden");
    }
  },
  
  _setContainerType: function(page)
  {
    page.attr("notebook", this);
  },
  
  _addToCItemConnections: function(toc_item)
  {
    // only called for vertical layout
    this.connect(toc_item, "onclick", this._onToCClick);
    this.connect(toc_item, "onmouseover", dojo.hitch(this, this._onToCOver));
    this.connect(toc_item, "onmouseout", dojo.hitch(this, this._onToCOut));
  },
  
  updateUI: function()
  {
    console.log("TivNotebook.updateUI");
    
    // disable the Apply button if the selected page does not validate
    var curr_page = this._pageContainer.selectedChildWidget;
    var isCurrentPageValid = curr_page && curr_page.isValid(); 
    if( !isCurrentPageValid )
      this._applyButton.attr("disabled", true);
        
    // disable the OK button until all pages are valid
    var allValid = dojo.every(this._pages, function(p){
      var v = p.isValid();
      return v;
     }, this);
    this._finishButton.attr("disabled", !allValid);
    this._applyButton.attr("disabled", !allValid);

    // if horizontal layout update invalid icon on tabs
    if ('h' === this.layout) {
      dojo.query(".tabLabel", this._pageContainer.tablist.domNode).forEach(function(n, i) {
        p = this._pages[i];
        dojo[(p && (!p.visited || p.validated)) ? "removeClass" : "addClass"](n, "tiv-page-invalid");
      }, this);     
    }
    this.inherited(arguments);
  },
  
  /**
   * If valid removes invalid icon on ToC item/tab.  If invalid adds invalid icon.  
   * Provided as a utility function when nesting this widget.
   */
  updateToCItemIcon: function(page, valid) {
    var toc_items;
    if ('h' === this.layout)
      toc_items = dojo.query(".tabLabel", this._pageContainer.tablist.domNode);
    else
      toc_items = dojo.query("li", this._toc);
    
    dojo.every(toc_items, function(n, i) {
      p = this._pages[i];
      if (page == p) {
        dojo[(valid) ? "removeClass" : "addClass"](n, "tiv-page-invalid");
        return false;
      }
      else 
        return true;
    }, this);      
  },
  
  _onToCOver: function(evt)
  {
    var li = evt.target;
    while(null != li && li.tagName.toLowerCase() != "li") {
      li = li.parentNode;
    }
    if(null == li) return;
    dojo.addClass(li, "over");
  },
  
  _onToCOut: function(evt)
  {
    var li = evt.target;
    while(null != li && li.tagName.toLowerCase() != "li") {
      li = li.parentNode;
    }
    if(null == li) return;
    dojo.removeClass(li, "over");    
  },
  
  _onToCClick: function(evt)
  {
    var li = evt.target;
    while(null != li && li.tagName.toLowerCase() != "li") {
      li = li.parentNode;
    }
    if(null == li) return;
    var pid = dojo.attr(li, "pageID");
    if(null != pid) {
      this.selectPage(pid);
    }
  },
  
  _onPageSelected: function(page) 
  {
    console.log("TivNotebook._onPageSelected: " + page.id);    
    page.visited = true;
    this.inherited(arguments);    
  },
  
  _onClickApply: function(evt)
  {
    console.log("TivNotebook._onClickApply");
    this.OnApply(this);
  },
  
  OnApply: function(wiz)
  {
    // override or connect to me
    
    // if this is still the same function as it was originally,
    // then nobody has connected to the event. do the default
    if(this._origApply === this.OnApply) {
      // nothing connected, do the default
      this.submit(this);
    }
  },
  
  /**
   * Enable (or disable) the OK button
   */
  enableOKButton: function(shouldEnable) 
  {
    this._finishButton.attr("disabled", !shouldEnable);
  },

  /**
   * Enable (or disable) the Apply button
   */
  enableApplyButton: function(shouldEnable) 
  {
    this._applyButton.attr("disabled", !shouldEnable);
  },

  /**
   * Hide (or show) the "OK" button
   */
  hideOKButton: function(shouldHide) 
  {
    this.hideFinishButton(shouldHide);
  },
  
  /**
   * Hide (or show) the "Apply" button
   */
  hideApplyButton: function(shouldHide) 
  {
    if (shouldHide) 
      dojo.style(this._applyButton.domNode, "display", "none");
    else 
      dojo.style(this._applyButton.domNode, "display", "inline-block");
  }
});


}
