/*
	Copyright (c) 2004-2010, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource["ibm.tivoli.tip.navwidget.dojo.NavWidgetBaseViewState"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["ibm.tivoli.tip.navwidget.dojo.NavWidgetBaseViewState"] = true;
dojo.provide("ibm.tivoli.tip.navwidget.dojo.NavWidgetBaseViewState");

dojo.require("dojox.collections.Dictionary");

dojo.declare(
    "ibm.tivoli.tip.navwidget.dojo.NavWidgetBaseViewState",
    null,
    {		
  		dataset: null,
    	stateData: null,
  		_viewStates: null,
  		
  		constructor: function(kwArgs) {
			//Look at kwArgs
    		if (kwArgs) {
    			this.view = kwArgs.view;
				this.dataset = kwArgs.dataset;		
				this.stateData = kwArgs.stateData;
			}
		
    		//Create internal data structure for states
    		this._viewStates = new dojox.collections.Dictionary();
	 	},
	 	
	 	addPluggableViewState: function(viewId, viewState) {
			this._viewStates.add(viewId, viewState);
		},

		getPluggableViewState: function(viewId) {
			return this._viewStates.item(viewId);
		},
		
		removePluggableViewState: function(viewId) {
			return this._viewStates.remove(viewId);
		},
		
		destroy: function() {
			this.dataset = null;
			this.stateData = null;
			if (this._viewStates) {
				this._viewStates.clear();
				this._viewStates = null;
			}
		}
    }
);

}
