/*
	Copyright (c) 2004-2010, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource["ibm.tivoli.tip.navwidget.iwidget.Edit"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["ibm.tivoli.tip.navwidget.iwidget.Edit"] = true;
dojo.provide("ibm.tivoli.tip.navwidget.iwidget.Edit");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.layout.BorderContainer");
dojo.require("dijit.layout.TabContainer");
dojo.require("dijit.layout.ContentPane");
dojo.require("dijit.form.NumberTextBox");
dojo.require("dijit.form.TextBox");
dojo.require("dijit.form.FilteringSelect");
dojo.require("dijit.form.CheckBox");
dojo.require("dojox.grid.DataGrid");
dojo.require("dojox.validate.web");
dojo.require("dojo.data.ItemFileReadStore");
dojo.require("dojo.data.ItemFileWriteStore");
dojo.require("dojo.html");
dojo.require("dojo.i18n");
    
dojo.requireLocalization("ibm.tivoli.tip.navwidget.iwidget", "Common", null, "ROOT,en,en-pi,en-us");

dojo.declare("ibm.tivoli.tip.navwidget.iwidget.Edit", [dijit.layout.ContentPane, dijit._Templated], {
    widgetsInTemplate: true,
    templateString:"<div dojoAttachPoint=\"containerNode\" class=\"tivoli_iWidget_Nav_Edit\" style=\"width: 810px; height: 100%; top: 0; left: 0; text-align: left;\">\n    <div tipdojoType=\"dijit.layout.BorderContainer\" dojoType=\"dijit.layout.BorderContainer\" dojoAttachPoint=\"borderContainer\" design=\"sidebar\" gutters=\"true\" style=\"width: 99%; padding: 2px; background: none\">\n        <div tipdojoType=\"dijit.layout.ContentPane\" dojoType=\"dijit.layout.ContentPane\" region=\"top\" style=\"text-align: left; padding: 2px\">\n          ${_descriptionText}\n        </div>\n        <div tipdojoType=\"dijit.layout.ContentPane\" dojoType=\"dijit.layout.ContentPane\" title=\"${_widgetDefTabText}\" style=\"background: none; padding: 2px\">\n          <form>\n              <fieldset title=\"${_widgetdefConfigText}\" style=\"border: 1px solid #CCCCCC; padding: 7px; background: none\">\n                  <legend>${_widgetdefConfigText}</legend>\n                  <label style=\"display: block; margin-bottom: 5px;\" for=\"baseUrlTextBox\">${_baseUrlText}</label>\n                  <div tipdojoType=\"dijit.form.TextBox\" dojoType=\"dijit.form.TextBox\" name=\"baseUrlTextBox\" dojoAttachPoint=\"baseUrlTextBox\" value=\"${defaultBaseUrl}\" style=\"display: block; width: 98%; margin-bottom: 10px;\"></div>\n                  <label style=\"display: block; margin-bottom: 5px;\" for=\"dataProviderTextBox\">${_dataProviderText}</label>\n                  <div tipdojoType=\"dijit.form.TextBox\" dojoType=\"dijit.form.TextBox\" name=\"dataProviderTextBox\" dojoAttachPoint=\"dataProviderTextBox\" value=\"${defaultDataProvider}\" style=\"display: block; width: 98%; margin-bottom: 10px;\"></div>\n                  <label style=\"display: block; margin-bottom: 5px;\" for=\"datasourceTextBox\">${_datasourceText}</label>\n                  <div tipdojoType=\"dijit.form.TextBox\" dojoType=\"dijit.form.TextBox\" name=\"datasourceTextBox\" dojoAttachPoint=\"datasourceTextBox\" value=\"${defaultDataSource}\" style=\"display: block; width: 98%; margin-bottom: 10px;\"></div>\n                  <label style=\"display: block; margin-bottom: 5px;\" for=\"widgetTextBox\">${_widgetText}</label>\n                  <div tipdojoType=\"dijit.form.TextBox\" readonly=\"true\" dojoType=\"dijit.form.TextBox\" name=\"widgetTextBox\" dojoAttachPoint=\"widgetTextBox\" value=\"${defaultWidget}\" style=\"display: block; width: 98%; margin-bottom: 10px;\"></div>\n                  <label style=\"display: block; margin-bottom: 5px;\">${_widgetdefText}</label>\n                  <div tipdojoType=\"dijit.form.TextBox\" dojoType=\"dijit.form.TextBox\" dojoAttachPoint=\"widgetDefTextBox\" value=\"${defaultWidgetDef}\" style=\"display: block; width: 98%\"></div>\n              </fieldset>              \n          </form>\n      </div>\n      <div dojoType=\"dijit.layout.ContentPane\" region=\"bottom\" style=\"text-align: left; padding: 2px\">\n            <div dojoAttachPoint=\"saveButton\" tipdojoType=\"dijit.form.Button\" dojoType=\"dijit.form.Button\" dojoAttachEvent='onClick:_onSave'>${_saveText}</div>\n            <div dojoAttachPoint=\"saveAndCloseButton\" tipdojoType=\"dijit.form.Button\" dojoType=\"dijit.form.Button\" dojoAttachEvent='onClick:_onSaveAndClose'>${_saveAndCloseText}</div>\n            <div dojoAttachPoint=\"restoreDefaultsButton\" tipdojoType=\"dijit.form.Button\" dojoType=\"dijit.form.Button\" dojoAttachEvent='onClick:_onRestoreDefaults'>${_restoreDefaultsText}</div>\n            <div dojoAttachPoint=\"closeButton\" tipdojoType=\"dijit.form.Button\" dojoType=\"dijit.form.Button\" dojoAttachEvent='onClick:_onClose'>${_closeText}</div>\n      </div>\n    </div>\n</div>\n",
    
    _descriptionText:null,
    _widgetDefTabText:null,
    _widgetdefConfigText:null,
    _baseUrlText:null,
    _dataProviderText:null,
    _datasourceText:null,
    _widgetText:null,
    _widgetdefText:null,
    _saveText:null,
    _saveAndCloseText:null,
    _restoreDefaultsText:null,
    _closeText:null,
    
    widgetDefInfo: null,
    providerInfo: null,
    _defaultBaseUrl: "/ibm/tivoli/rest",
    _defaultDataProvider: "tip",
    _defaultWidget: "",
    _defaultDataSource: "any",
    _defaultWidgetDef: "SampleNavWidgetWithTableOnTop-0.1.0",
    
    constructor: function constructor(){
        var i18nHash = dojo.i18n.getLocalization("ibm.tivoli.tip.navwidget.iwidget", "Common");
        this._descriptionText=    i18nHash["Edit Mode's Description"];
        this._widgetDefTabText=   i18nHash["Widget Definition"];
        this._widgetdefConfigText=i18nHash["Widget Definition Configuration"];
        this._baseUrlText=        i18nHash["Base URL"];
        this._dataProviderText=   i18nHash["Provider"];
        this._datasourceText=     i18nHash["Datasource"];
        this._widgetText=         i18nHash["Widget Type"];
        this._widgetdefText=      i18nHash["Widget Id"];
        this._saveText=           i18nHash["Save"];
        this._saveAndCloseText=   i18nHash["Save and Close"];
        this._restoreDefaultsText=i18nHash["Restore Defaults"];
        this._closeText=          i18nHash["Close"];
    },
    startup: function startup(){
        this.updateWidgetDefInfo(this.widgetDefInfo);
    },
    //BUTTON ACTIONS
    onSave: function onSave(/* Event */e){ /* Extension point.*/ },
    _onSave: function _onSave(/* Event */e){
        this.widgetDefInfo = {};
        this.widgetDefInfo.baseUrl = this.baseUrlTextBox.attr('value');
        this.widgetDefInfo.provider = this.dataProviderTextBox.attr('value');
        this.widgetDefInfo.datasource = this.datasourceTextBox.attr('value');
        this.widgetDefInfo.widget = this.widgetTextBox.attr('value');
        this.widgetDefInfo.definition = this.widgetDefTextBox.attr('value');
        e.payload = this.widgetDefInfo;
        return this.onSave(e);
    },
    onSaveAndClose: function onSaveAndClose(/* Event */e){ /* Extension point.*/ },
    _onSaveAndClose: function _onSaveAndClose(/* Event */e){
        return this._onSave(e) || this._onClose(e) || this.onSaveAndClose(e);
    },
    onRestoreDefaults: function onRestoreDefaults(/* Event */e){ /* Extension point.*/ },
    _onRestoreDefaults: function _onRestoreDefaults(/* Event */e){
        this.baseUrlTextBox.reset();
        this.dataProviderTextBox.reset();
        this.datasourceTextBox.reset();
        this.widgetDefTextBox.reset();
        return this.onRestoreDefaults(e);
    },
    onClose: function onClose(/* Event */e){ /* Extension point.*/ },
    _onClose: function _onClose(/* Event */e){
        return this.onClose(e);
    },    
    updateWidgetDefInfo: function updateWidgetDefInfo(/* object */widgetDefInfo){        
        if (widgetDefInfo == null || typeof widgetDefInfo == 'undefined') {
          return;
        }
        this.baseUrlTextBox.attr('value', widgetDefInfo.baseUrl);
        this.dataProviderTextBox.attr('value', widgetDefInfo.provider);
        this.datasourceTextBox.attr('value', widgetDefInfo.datasource);
        this.widgetTextBox.attr('value', widgetDefInfo.widget);
        this.widgetDefTextBox.attr('value', widgetDefInfo.definition);
    }
});

}
