/*
	Copyright (c) 2004-2010, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource["ibm.tivoli.tip.navwidget.iwidget.event.NameMatchDatasetFactory"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["ibm.tivoli.tip.navwidget.iwidget.event.NameMatchDatasetFactory"] = true;
dojo.provide("ibm.tivoli.tip.navwidget.iwidget.event.NameMatchDatasetFactory");

dojo.require("ibm.tivoli.tip.navwidget.iwidget.event.AbstractDatasetFactory");

dojo.declare("ibm.tivoli.tip.navwidget.iwidget.event.NameMatchDatasetFactory",[ibm.tivoli.tip.navwidget.iwidget.event.AbstractDatasetFactory],{
	providersCache:null,
	constructor: function constructor(templateDataset,providerType,providersCache){
		this.providerType=providerType;
		this.providersCache=providersCache;
	},
	createDataset: function createDataset(resources,event){
		if(resources.length===0){return false;}
		var mssName=this._getCommonProviderMSSName(resources);
		if(!mssName){return false;}
		var provider=this.providersCache[mssName];
		if(!provider){return false;}
		this._initProviderInfo(provider);
		return this.inherited(arguments);
	},
	_handleWithMissingAttrs: function _handleWithMissingAttrs(resources,commonAttrs){
		return this._handleWithItemIdsOrFail(resources,commonAttrs);
	},
	_handleWithUnknownParams: function _handleWithUnknownParams(resources){
		var commonAttrs=this._getCommonAttributes(resources);
		return this._handleWithItemIdsOrFail(resources,commonAttrs);
	},
	_handleWithItemIdsOrFail: function _handleWithItemIdsOrFail(resources,commonAttrs){
		if(dojo.indexOf(commonAttrs,"ItemId")===-1){
			return this._cannotHandleEvent();
		}else{
			return this._createDatasetPlusItemIds(resources);
		}
	},
	_getCommonProviderMSSName: function _getCommonProviderMSSName(resources){
		var mssName=null;
		var provType=this.providerType;
		var compare=function(resource,index){
			if(index===0){
				mssName=resource.getMSSNameByProviderType(provType);
				return true;
			} else {
				return mssName===resource.getMSSNameByProviderType(provType);
			}
		};
		if(!mssName){mssName="__INFOHUB__";}
		return dojo.every(resources,compare)?mssName:null;
	}
});

}
