/*
	Copyright (c) 2004-2010, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource["itme.ChassisMap.ChassisMapTooltip"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["itme.ChassisMap.ChassisMapTooltip"] = true;
dojo.provide("itme.ChassisMap.ChassisMapTooltip");

dojo.require("dijit.Tooltip");

 function CMAdditionalProperties(focusName)
  {
    this.name = focusName;
    this.isEnabled = false;
    this.valueNames = [];
    this.valueValues = [];
  }

  function CMPropIndexOf(array, valueToFind) {
    for ( var i = 0; i < array.length; i++) {
      if ( array[i].name == valueToFind)
        return i;
    }
    return -1;
  }

var myTooltipCounter = 0;

dojo.declare("itme.ChassisMap.ChassisMapTooltip", [/*dijit.Tooltip*/], {

  _parentElement: null,
  _numBaseProperties: 0,
  _baseProperties: [],
  _focusList: [],
  _title: null,
  _dijitTooltipObject: null,
  _isFocusEnabled: [],
  
  constructor: function(kwArgs, mapElement) {
    this._parentElement = mapElement; 
    this._parentElement.CMTooltip = this;
    this._focusList= [];
    this._baseProperties = [];
  },

 

  setTitle: function(title) {
    this._title = title;
  },
  
  addBaseProperty: function(name, value) {
    this._baseProperties[this._numBaseProperties++] = "<tr><td class='CMTooltipTitle'>"+name+"</td><td class='CMTooltipValue'>"+value+"</td></tr>";
  },
  
  addFocusProperty: function(focus, name, value) {
    
    var index = CMPropIndexOf(this._focusList, focus);
    if (index < 0) {
      index = this._focusList.length;
      this._focusList[index] = new CMAdditionalProperties(focus);
    }
    
    var len = this._focusList[index].valueNames.length;
    this._focusList[index].valueNames[len] = name;
    this._focusList[index].valueValues[len] = value;
  },
  
  buildTooltip: function() {
    var tooltipString = this.__addTooltipHeader() +
                        this.__addTooltipBaseProps() +
                        this.__addTooltipFocusProps() +
                        this.__addTooltipFooter();
    
    try {
      if (this._dijitTooltipObject) 
        this._dijitTooltipObject.attr("label", tooltipString);
      else { 
        this._dijitTooltipObject = new dijit.Tooltip({
          connectId: [this._parentElement],
          label: tooltipString,
          id: "myTooltip_" + myTooltipCounter
        });
        myTooltipCounter++;
      }
      this._dijitTooltipObject.defaultPosition= ["after", "before", "below"];
    } catch (err) {
      itmeUtils.CMTrace("MAIN", "dojo hitch error?: " + err);
    }
  },
  
  __addTooltipHeader: function() {
    
    var tooltipStr = "<div class='DeviceTooltip' style='max-width:450px'><h3 class='DeviceTooltipTitle'>" + this._title + "</h3>" +
                        "<div>" + "" + "</div>" +  
                        "<table>";
    return tooltipStr;
  },
  
  __addTooltipBaseProps: function() {
    
    var tooltipStr = "";
    for (var i = 0; i < this._baseProperties.length; i++)    
      tooltipStr += this._baseProperties[i];                    
    return tooltipStr;
  },

  __addTooltipFocusProps: function() {

    var tooltipStr = "";
    
    for ( var i = 0; i < this._focusList.length; i++) {
      if ( this._focusList[i].isEnabled ) {
        tooltipStr += "<tr><td colspan=2><hr class='tooltiphr'></td></tr>"; 
        for (var j = 0; j < this._focusList[i].valueNames.length; j++) {
          tooltipStr += "<tr><td class='CMTooltipTitle'>"+this._focusList[i].valueNames[j]+"</td><td class='CMTooltipValue'>"+this._focusList[i].valueValues[j]+"</td></tr>";;
        }     
      }
    }
    
    return tooltipStr;
  },

  __addTooltipFooter: function(tooltipStr) {
    
    var tooltipStr = "</table></div>";
    return tooltipStr;
  },
  
  toggleFocusEnabled: function(focus, bEnabled) {
    var index = CMPropIndexOf(this._focusList, focus);
    if ( index >= 0)
      this._focusList[index].isEnabled = bEnabled; 
  }
  
// Tooltip 

// constructor (mapElement);
// addBaseProperty(title, value);
// addFocusProperty(focus, title, value);
// switchTooltipFocus(focus)

// buildTooltip()
//  div
//    header
//    table
//      basePropertyTitle - basePropertyValue
//    /table

// if (activeFocus)

//    div id=focus
//      -------------------<hr>
//      table
// for (eachFocusProperty)
//        focusPropertyTitle - focusPropertyValue
//      /table
//    /div
//  /div


// 
});

}
