/*
	Copyright (c) 2004-2010, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource["itme.ChassisMap._Layout"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["itme.ChassisMap._Layout"] = true;
dojo.provide("itme.ChassisMap._Layout");

dojo.require("itme.ChassisMap._Utils");
dojo.require("itme.ChassisMap.ImageResources");
dojo.require("dojo.i18n");

dojo.declare("itme.ChassisMap._Layout", null, {
  // public members FINAL
  ITE_Name: "ITE",
  FAN_Name: "FAN",
  FAN2_Name: "FAN2_",
  FANCTRL_Name: "FANCTRL_",
  PWR_Name: "PWR",
  MGT_Name: "MGT",
  IOM_Name: "IOM",
  DLM_Name: "DLink",
  SPC1_Name: "SPC1_",
  SPC2_Name: "SPC2_",
  MRI: null,
  IMAGES : new itme.ChassisMap.ImageResources(),
  
  // private members
  _args: null,                      // presently unused
  _chassisSlotInformation1: null,   // default view (defined below)
  _chassisSlotInformation2: null,   // alternate view
  _chassisSlotInformation3: null,   // default view - no spacing betwixt components
  _chassisSlotInformation4: null,
  _chassisSlotInformation5: null,
  _chassisSlotInformation6: null,
  _chassisLayoutInformation: null,  // used view, set in constructor
  
  _chassisMapFaceElements: [],      // stores the chassis face dom elements.  Indexed BOTH by name & numerically     
  _numFaceElements: 0,              // for numerical indexing of the face elements
  _chassisNameElement: null,        // the chassis header dome element
  _chassisOverlayElement: null,
  
  _chassisMapParentDOMNodeID: null,
  
  // 821w matches the given images sizes from karen.
  // 418 , 230 I think was the original
  // 600 , 300
  // 750 , 396
  _viewWidth: 892,          /*896 822*/ // default width , gets changed to match the given node, if given
  _viewHeight: 422,         /*440 422 457 442 */ // default width , gets changed to match the given node, if given
  _filterBarHeight: 32,     // filter bar height
  _containingDomNode: null, // if set, dimensions for the view are set from this node.
  
  _resizingTimeoutDelay: false,  // false when not set, otherwise used to track the window drag timeout so we only resize once per drag not on every event
  _resizeEnabled: false,
 
  constructor: function(kwArgs, chassisMapParentDOMNodeID)
  {
    dojo.requireLocalization("itme", "Resources", null, "ROOT");
    this.MRI = dojo.i18n.getLocalization("itme", "Resources");
    
    //this._args = {};
    //dojo.mixin(this._args, kwArgs);

    // indexes to facilitate defining layouts locally
    var ITEIndex = 0;
    var FanIndex = 0;
    var PwrIndex = 0;
    var MgtIndex = 0;
    var IOmIndex = 0;
    var DLmIndex = 0;
    
    this._chassisMapParentDOMNodeID = chassisMapParentDOMNodeID;
    
    // DEFAULT 
    /*
    this._chassisSlotInformation1 = 
                  {"numberOfMapFaces":2, "mapFaces":[
                    {"mapName":"front","mapWidth":188,"mapHeight":162},
                    {"mapName":"back","mapWidth":188,"mapHeight":162} ],
                   "numberOfSlotTypes":7,"slots":[
                    {"slotType":this.ITE_Name,"slotCount":14,"slotWidth":91,"slotHeight":20,"slotPositioning":[
                      {"slotID":this.ITE_Name+(ITEIndex++),"mapFace":"front","X":0,"Y":0},
                      {"slotID":this.ITE_Name+(ITEIndex++),"mapFace":"front","X":94,"Y":0},
                      {"slotID":this.ITE_Name+(ITEIndex++),"mapFace":"front","X":0,"Y":23},
                      {"slotID":this.ITE_Name+(ITEIndex++),"mapFace":"front","X":94,"Y":23},
                      {"slotID":this.ITE_Name+(ITEIndex++),"mapFace":"front","X":0,"Y":46},
                      {"slotID":this.ITE_Name+(ITEIndex++),"mapFace":"front","X":94,"Y":46},
                      {"slotID":this.ITE_Name+(ITEIndex++),"mapFace":"front","X":0,"Y":69},
                      {"slotID":this.ITE_Name+(ITEIndex++),"mapFace":"front","X":94,"Y":69},
                      {"slotID":this.ITE_Name+(ITEIndex++),"mapFace":"front","X":0,"Y":92},
                      {"slotID":this.ITE_Name+(ITEIndex++),"mapFace":"front","X":94,"Y":92},
                      {"slotID":this.ITE_Name+(ITEIndex++),"mapFace":"front","X":0,"Y":115},
                      {"slotID":this.ITE_Name+(ITEIndex++),"mapFace":"front","X":94,"Y":115},
                      {"slotID":this.ITE_Name+(ITEIndex++),"mapFace":"front","X":0,"Y":138},
                      {"slotID":this.ITE_Name+(ITEIndex++),"mapFace":"front","X":94,"Y":138} ] },
                    {"slotType":this.FAN_Name,"slotCount":10,"slotWidth":30,"slotHeight":29,"slotPositioning":[
                      {"slotID":this.FAN_Name+(FanIndex++),"mapFace":"back","X":31,"Y":0},
                      {"slotID":this.FAN_Name+(FanIndex++),"mapFace":"back","X":31,"Y":32},
                      {"slotID":this.FAN_Name+(FanIndex++),"mapFace":"back","X":31,"Y":64},
                      {"slotID":this.FAN_Name+(FanIndex++),"mapFace":"back","X":31,"Y":96},
                      {"slotID":this.FAN_Name+(FanIndex++),"mapFace":"back","X":31,"Y":128},
                      {"slotID":this.FAN_Name+(FanIndex++),"mapFace":"back","X":122,"Y":0},
                      {"slotID":this.FAN_Name+(FanIndex++),"mapFace":"back","X":122,"Y":32},
                      {"slotID":this.FAN_Name+(FanIndex++),"mapFace":"back","X":122,"Y":64},
                      {"slotID":this.FAN_Name+(FanIndex++),"mapFace":"back","X":122,"Y":96},
                      {"slotID":this.FAN_Name+(FanIndex++),"mapFace":"back","X":122,"Y":128} ] },
                    {"slotType":this.FAN_Name,"slotCount":2,"slotWidth":54,"slotHeight":25,"slotPositioning":[
                      {"slotID":this.FAN_Name+(FanIndex++),"mapFace":"back","X":64,"Y":0},
                      {"slotID":this.FAN_Name+(FanIndex++),"mapFace":"back","X":64,"Y":135} ] },
                    {"slotType":this.PWR_Name,"slotCount":6,"slotWidth":16,"slotHeight":51,"slotPositioning":[
                      {"slotID":this.PWR_Name+(PwrIndex++),"mapFace":"back","X":12,"Y":0},
                      {"slotID":this.PWR_Name+(PwrIndex++),"mapFace":"back","X":12,"Y":54},
                      {"slotID":this.PWR_Name+(PwrIndex++),"mapFace":"back","X":12,"Y":108},
                      {"slotID":this.PWR_Name+(PwrIndex++),"mapFace":"back","X":155,"Y":0},
                      {"slotID":this.PWR_Name+(PwrIndex++),"mapFace":"back","X":155,"Y":54},
                      {"slotID":this.PWR_Name+(PwrIndex++),"mapFace":"back","X":155,"Y":108} ] },
                    {"slotType":this.MGT_Name,"slotCount":2,"slotWidth":9,"slotHeight":78,"slotPositioning":[
                      {"slotID":this.MGT_Name+(MgtIndex++),"mapFace":"back","X":0,"Y":0},
                      {"slotID":this.MGT_Name+(MgtIndex++),"mapFace":"back","X":174,"Y":81} ] },
                    {"slotType":this.IOM_Name,"slotCount":4,"slotWidth":11,"slotHeight":104,"slotPositioning":[
                      {"slotID":this.IOM_Name+(IOmIndex++),"mapFace":"back","X":64,"Y":28},
                      {"slotID":this.IOM_Name+(IOmIndex++),"mapFace":"back","X":78,"Y":28},
                      {"slotID":this.IOM_Name+(IOmIndex++),"mapFace":"back","X":92,"Y":28},
                      {"slotID":this.IOM_Name+(IOmIndex++),"mapFace":"back","X":106,"Y":28} ] },
                    {"slotType":this.DLM_Name,"slotCount":2,"slotWidth":9,"slotHeight":78,"slotPositioning":[
                      {"slotID":this.DLM_Name+(DLmIndex++),"mapFace":"back","X":174,"Y":0},
                      {"slotID":this.DLM_Name+(DLmIndex++),"mapFace":"back","X":0,"Y":81} ] }
                    ]
                };

    ITEIndex = FanIndex = PwrIndex = MgtIndex = IOmIndex = DLmIndex = 0;

    // ALTERNATE LAYOUT
    this._chassisSlotInformation2 =
                {"numberOfMapFaces":2, "mapFaces":[
                    {"mapName":"front","mapWidth":190,"mapHeight":165},
                    {"mapName":"back","mapWidth":190,"mapHeight":165} ],
                 "numberOfSlotTypes":6,"slots":[
                  {"slotType":this.ITE_Name,"slotCount":10,"slotWidth":185,"slotHeight":13,"slotPositioning":[
                    {"slotID":this.ITE_Name+(ITEIndex++),"mapFace":"front","X":0,"Y":0},
                    {"slotID":this.ITE_Name+(ITEIndex++),"mapFace":"front","X":0,"Y":16},
                    {"slotID":this.ITE_Name+(ITEIndex++),"mapFace":"front","X":0,"Y":32},
                    {"slotID":this.ITE_Name+(ITEIndex++),"mapFace":"front","X":0,"Y":48},
                    {"slotID":this.ITE_Name+(ITEIndex++),"mapFace":"front","X":0,"Y":64},
                    {"slotID":this.ITE_Name+(ITEIndex++),"mapFace":"front","X":0,"Y":80},
                    {"slotID":this.ITE_Name+(ITEIndex++),"mapFace":"front","X":0,"Y":96},
                    {"slotID":this.ITE_Name+(ITEIndex++),"mapFace":"front","X":0,"Y":112},
                    {"slotID":this.ITE_Name+(ITEIndex++),"mapFace":"front","X":0,"Y":128},
                    {"slotID":this.ITE_Name+(ITEIndex++),"mapFace":"front","X":0,"Y":144} ] },
                  {"slotType":this.FAN_Name,"slotCount":10,"slotWidth":34,"slotHeight":30,"slotPositioning":[
                    {"slotID":this.FAN_Name+(FanIndex++),"mapFace":"back","X":0,"Y":18},
                    {"slotID":this.FAN_Name+(FanIndex++),"mapFace":"back","X":37,"Y":18},
                    {"slotID":this.FAN_Name+(FanIndex++),"mapFace":"back","X":74,"Y":18},
                    {"slotID":this.FAN_Name+(FanIndex++),"mapFace":"back","X":111,"Y":18},
                    {"slotID":this.FAN_Name+(FanIndex++),"mapFace":"back","X":148,"Y":18},
                    {"slotID":this.FAN_Name+(FanIndex++),"mapFace":"back","X":0,"Y":113},
                    {"slotID":this.FAN_Name+(FanIndex++),"mapFace":"back","X":37,"Y":113},
                    {"slotID":this.FAN_Name+(FanIndex++),"mapFace":"back","X":74,"Y":113},
                    {"slotID":this.FAN_Name+(FanIndex++),"mapFace":"back","X":111,"Y":113},
                    {"slotID":this.FAN_Name+(FanIndex++),"mapFace":"back","X":148,"Y":113} ] },
                  {"slotType":this.PWR_Name,"slotCount":6,"slotWidth":20,"slotHeight":60,"slotPositioning":[
                    {"slotID":this.PWR_Name+(PwrIndex++),"mapFace":"back","X":15,"Y":50},
                    {"slotID":this.PWR_Name+(PwrIndex++),"mapFace":"back","X":38,"Y":50},
                    {"slotID":this.PWR_Name+(PwrIndex++),"mapFace":"back","X":61,"Y":50},
                    {"slotID":this.PWR_Name+(PwrIndex++),"mapFace":"back","X":84,"Y":50},
                    {"slotID":this.PWR_Name+(PwrIndex++),"mapFace":"back","X":107,"Y":50},
                    {"slotID":this.PWR_Name+(PwrIndex++),"mapFace":"back","X":130,"Y":50} ] },
                  {"slotType":this.MGT_Name,"slotCount":2,"slotWidth":12,"slotHeight":60,"slotPositioning":[
                    {"slotID":this.MGT_Name+(MgtIndex++),"mapFace":"back","X":0,"Y":50},
                    {"slotID":this.MGT_Name+(MgtIndex++),"mapFace":"back","X":175,"Y":50} ] },
                  {"slotType":this.IOM_Name,"slotCount":4,"slotWidth":91,"slotHeight":15,"slotPositioning":[
                    {"slotID":this.IOM_Name+(IOmIndex++),"mapFace":"back","X":0,"Y":0},
                    {"slotID":this.IOM_Name+(IOmIndex++),"mapFace":"back","X":94,"Y":0},
                    {"slotID":this.IOM_Name+(IOmIndex++),"mapFace":"back","X":0,"Y":144},
                    {"slotID":this.IOM_Name+(IOmIndex++),"mapFace":"back","X":94,"Y":144} ] },
                  {"slotType":this.DLM_Name,"slotCount":2,"slotWidth":8,"slotHeight":60,"slotPositioning":[
                    {"slotID":this.DLM_Name+(DLmIndex++),"mapFace":"back","X":153,"Y":50},
                    {"slotID":this.DLM_Name+(DLmIndex++),"mapFace":"back","X":164,"Y":50} ] }
                  ]
              };
              
    ITEIndex = FanIndex = PwrIndex = MgtIndex = IOmIndex = DLmIndex = 0;

    // DEFAULT + NO SPACING BETWEEN COMPONENTS
    this._chassisSlotInformation3 = 
              {"numberOfMapFaces":2, "mapFaces":[
                {"mapName":"front","mapWidth":190,"mapHeight":165},
                {"mapName":"back","mapWidth":190,"mapHeight":165} ],
               "numberOfSlotTypes":7,"slots":[
                {"slotType":this.ITE_Name,"slotCount":14,"slotWidth":94,"slotHeight":23,"slotPositioning":[
                  {"slotID":this.ITE_Name+(ITEIndex++),"mapFace":"front","X":0,"Y":0},
                  {"slotID":this.ITE_Name+(ITEIndex++),"mapFace":"front","X":94,"Y":0},
                  {"slotID":this.ITE_Name+(ITEIndex++),"mapFace":"front","X":0,"Y":23},
                  {"slotID":this.ITE_Name+(ITEIndex++),"mapFace":"front","X":94,"Y":23},
                  {"slotID":this.ITE_Name+(ITEIndex++),"mapFace":"front","X":0,"Y":46},
                  {"slotID":this.ITE_Name+(ITEIndex++),"mapFace":"front","X":94,"Y":46},
                  {"slotID":this.ITE_Name+(ITEIndex++),"mapFace":"front","X":0,"Y":69},
                  {"slotID":this.ITE_Name+(ITEIndex++),"mapFace":"front","X":94,"Y":69},
                  {"slotID":this.ITE_Name+(ITEIndex++),"mapFace":"front","X":0,"Y":92},
                  {"slotID":this.ITE_Name+(ITEIndex++),"mapFace":"front","X":94,"Y":92},
                  {"slotID":this.ITE_Name+(ITEIndex++),"mapFace":"front","X":0,"Y":115},
                  {"slotID":this.ITE_Name+(ITEIndex++),"mapFace":"front","X":94,"Y":115},
                  {"slotID":this.ITE_Name+(ITEIndex++),"mapFace":"front","X":0,"Y":138},
                  {"slotID":this.ITE_Name+(ITEIndex++),"mapFace":"front","X":94,"Y":138} ] },
                {"slotType":this.FAN_Name,"slotCount":10,"slotWidth":33,"slotHeight":33,"slotPositioning":[
                  {"slotID":this.FAN_Name+(FanIndex++),"mapFace":"back","X":31,"Y":0},
                  {"slotID":this.FAN_Name+(FanIndex++),"mapFace":"back","X":31,"Y":33},
                  {"slotID":this.FAN_Name+(FanIndex++),"mapFace":"back","X":31,"Y":66},
                  {"slotID":this.FAN_Name+(FanIndex++),"mapFace":"back","X":31,"Y":99},
                  {"slotID":this.FAN_Name+(FanIndex++),"mapFace":"back","X":31,"Y":132},
                  {"slotID":this.FAN_Name+(FanIndex++),"mapFace":"back","X":122,"Y":0},
                  {"slotID":this.FAN_Name+(FanIndex++),"mapFace":"back","X":122,"Y":33},
                  {"slotID":this.FAN_Name+(FanIndex++),"mapFace":"back","X":122,"Y":66},
                  {"slotID":this.FAN_Name+(FanIndex++),"mapFace":"back","X":122,"Y":99},
                  {"slotID":this.FAN_Name+(FanIndex++),"mapFace":"back","X":122,"Y":132} ] },
                {"slotType":this.FAN_Name,"slotCount":2,"slotWidth":55,"slotHeight":28,"slotPositioning":[
                  {"slotID":this.FAN_Name+(FanIndex++),"mapFace":"back","X":66,"Y":0},
                  {"slotID":this.FAN_Name+(FanIndex++),"mapFace":"back","X":66,"Y":135} ] },
                {"slotType":this.PWR_Name,"slotCount":6,"slotWidth":19,"slotHeight":54,"slotPositioning":[
                  {"slotID":this.PWR_Name+(PwrIndex++),"mapFace":"back","X":12,"Y":0},
                  {"slotID":this.PWR_Name+(PwrIndex++),"mapFace":"back","X":12,"Y":54},
                  {"slotID":this.PWR_Name+(PwrIndex++),"mapFace":"back","X":12,"Y":108},
                  {"slotID":this.PWR_Name+(PwrIndex++),"mapFace":"back","X":155,"Y":0},
                  {"slotID":this.PWR_Name+(PwrIndex++),"mapFace":"back","X":155,"Y":54},
                  {"slotID":this.PWR_Name+(PwrIndex++),"mapFace":"back","X":155,"Y":108} ] },
                {"slotType":this.MGT_Name,"slotCount":2,"slotWidth":12,"slotHeight":81,"slotPositioning":[
                  {"slotID":this.MGT_Name+(MgtIndex++),"mapFace":"back","X":0,"Y":0},
                  {"slotID":this.MGT_Name+(MgtIndex++),"mapFace":"back","X":174,"Y":82} ] },
                {"slotType":this.IOM_Name,"slotCount":4,"slotWidth":12,"slotHeight":106,"slotPositioning":[
                  {"slotID":this.IOM_Name+(IOmIndex++),"mapFace":"back","X":66,"Y":29},
                  {"slotID":this.IOM_Name+(IOmIndex++),"mapFace":"back","X":80,"Y":29},
                  {"slotID":this.IOM_Name+(IOmIndex++),"mapFace":"back","X":93,"Y":29},
                  {"slotID":this.IOM_Name+(IOmIndex++),"mapFace":"back","X":108,"Y":29} ] },
                {"slotType":this.DLM_Name,"slotCount":2,"slotWidth":12,"slotHeight":81,"slotPositioning":[
                  {"slotID":this.DLM_Name+(DLmIndex++),"mapFace":"back","X":174,"Y":0},
                  {"slotID":this.DLM_Name+(DLmIndex++),"mapFace":"back","X":0,"Y":82} ] }
                ]
            };

    ITEIndex = FanIndex = PwrIndex = MgtIndex = IOmIndex = DLmIndex = 0;
    
    // OLD 
    this._chassisSlotInformation4 = 
                  {"numberOfMapFaces":2, "mapFaces":[
                    {"mapName":"front","mapWidth":188,"mapHeight":162},
                    {"mapName":"back","mapWidth":188,"mapHeight":162} ],
                   "numberOfSlotTypes":8,"slots":[
                    {"slotType":this.ITE_Name,"slotCount":10,"slotWidth":91,"slotHeight":20,"slotPositioning":[
                      {"slotID":this.ITE_Name+"0","mapFace":"front","X":0,"Y":0},
                      {"slotID":this.ITE_Name+"1","mapFace":"front","X":94,"Y":0},
                      {"slotID":this.ITE_Name+"3","mapFace":"front","X":0,"Y":46},
                      {"slotID":this.ITE_Name+"4","mapFace":"front","X":94,"Y":46},
                      {"slotID":this.ITE_Name+"5","mapFace":"front","X":0,"Y":69},
                      {"slotID":this.ITE_Name+"6","mapFace":"front","X":94,"Y":69},
                      {"slotID":this.ITE_Name+"8","mapFace":"front","X":0,"Y":115},
                      {"slotID":this.ITE_Name+"9","mapFace":"front","X":94,"Y":115},
                      {"slotID":this.ITE_Name+"10","mapFace":"front","X":0,"Y":138},
                      {"slotID":this.ITE_Name+"11","mapFace":"front","X":94,"Y":138} ] },
                    {"slotType":this.ITE_Name,"slotCount":2,"slotWidth":185,"slotHeight":20,"slotPositioning":[
                      {"slotID":this.ITE_Name+"2","mapFace":"front","X":0,"Y":23},
                      {"slotID":this.ITE_Name+"7","mapFace":"front","X":0,"Y":92} ] },
                    {"slotType":this.FAN_Name,"slotCount":10,"slotWidth":30,"slotHeight":29,"slotPositioning":[
                      {"slotID":this.FAN_Name+(FanIndex++),"mapFace":"back","X":31,"Y":0},
                      {"slotID":this.FAN_Name+(FanIndex++),"mapFace":"back","X":31,"Y":32},
                      {"slotID":this.FAN_Name+(FanIndex++),"mapFace":"back","X":31,"Y":64},
                      {"slotID":this.FAN_Name+(FanIndex++),"mapFace":"back","X":31,"Y":96},
                      {"slotID":this.FAN_Name+(FanIndex++),"mapFace":"back","X":31,"Y":128},
                      {"slotID":this.FAN_Name+(FanIndex++),"mapFace":"back","X":122,"Y":0},
                      {"slotID":this.FAN_Name+(FanIndex++),"mapFace":"back","X":122,"Y":32},
                      {"slotID":this.FAN_Name+(FanIndex++),"mapFace":"back","X":122,"Y":64},
                      {"slotID":this.FAN_Name+(FanIndex++),"mapFace":"back","X":122,"Y":96},
                      {"slotID":this.FAN_Name+(FanIndex++),"mapFace":"back","X":122,"Y":128} ] },
                    {"slotType":this.FAN_Name,"slotCount":2,"slotWidth":54,"slotHeight":25,"slotPositioning":[
                      {"slotID":this.FAN_Name+(FanIndex++),"mapFace":"back","X":64,"Y":0},
                      {"slotID":this.FAN_Name+(FanIndex++),"mapFace":"back","X":64,"Y":135} ] },
                    {"slotType":this.PWR_Name,"slotCount":6,"slotWidth":16,"slotHeight":51,"slotPositioning":[
                      {"slotID":this.PWR_Name+(PwrIndex++),"mapFace":"back","X":12,"Y":0},
                      {"slotID":this.PWR_Name+(PwrIndex++),"mapFace":"back","X":12,"Y":54},
                      {"slotID":this.PWR_Name+(PwrIndex++),"mapFace":"back","X":12,"Y":108},
                      {"slotID":this.PWR_Name+(PwrIndex++),"mapFace":"back","X":155,"Y":0},
                      {"slotID":this.PWR_Name+(PwrIndex++),"mapFace":"back","X":155,"Y":54},
                      {"slotID":this.PWR_Name+(PwrIndex++),"mapFace":"back","X":155,"Y":108} ] },
                    {"slotType":this.MGT_Name,"slotCount":2,"slotWidth":9,"slotHeight":78,"slotPositioning":[
                      {"slotID":this.MGT_Name+(MgtIndex++),"mapFace":"back","X":0,"Y":0},
                      {"slotID":this.MGT_Name+(MgtIndex++),"mapFace":"back","X":174,"Y":81} ] },
                    {"slotType":this.IOM_Name,"slotCount":4,"slotWidth":11,"slotHeight":104,"slotPositioning":[
                      {"slotID":this.IOM_Name+(IOmIndex++),"mapFace":"back","X":64,"Y":28},
                      {"slotID":this.IOM_Name+(IOmIndex++),"mapFace":"back","X":78,"Y":28},
                      {"slotID":this.IOM_Name+(IOmIndex++),"mapFace":"back","X":92,"Y":28},
                      {"slotID":this.IOM_Name+(IOmIndex++),"mapFace":"back","X":106,"Y":28} ] },
                    {"slotType":this.DLM_Name,"slotCount":2,"slotWidth":9,"slotHeight":78,"slotPositioning":[
                      {"slotID":this.DLM_Name+(DLmIndex++),"mapFace":"back","X":174,"Y":0},
                      {"slotID":this.DLM_Name+(DLmIndex++),"mapFace":"back","X":0,"Y":81} ] }
                    ]
                };
    */
    ITEIndex = FanIndex = PwrIndex = MgtIndex = IOmIndex = DLmIndex = 0;
    
    // OLD 
    /*this._chassisSlotInformation5 = 
                  {"numberOfMapFaces":2, "mapFaces":[
                    {"mapName":"front","mapWidth":401,"mapHeight":343},
                    {"mapName":"back","mapWidth":401,"mapHeight":343} ],
                   "numberOfSlotTypes":7,"slots":[
                    {"slotType":this.ITE_Name,"slotCount":14,"slotWidth":194,"slotHeight":43,"slotPositioning":[
                      {"slotID":this.ITE_Name+"1","mapFace":"front","X":0,"Y":0},
                      {"slotID":this.ITE_Name+"2","mapFace":"front","X":199,"Y":0},
                      {"slotID":this.ITE_Name+"3","mapFace":"front","X":0,"Y":48},
                      {"slotID":this.ITE_Name+"4","mapFace":"front","X":199,"Y":48},
                      {"slotID":this.ITE_Name+"5","mapFace":"front","X":0,"Y":97},
                      {"slotID":this.ITE_Name+"6","mapFace":"front","X":199,"Y":97},
                      {"slotID":this.ITE_Name+"7","mapFace":"front","X":0,"Y":146},
                      {"slotID":this.ITE_Name+"8","mapFace":"front","X":199,"Y":146},
                      {"slotID":this.ITE_Name+"9","mapFace":"front","X":0,"Y":195},   
                      {"slotID":this.ITE_Name+"10","mapFace":"front","X":199,"Y":195}, 
                      {"slotID":this.ITE_Name+"11","mapFace":"front","X":0,"Y":244},
                      {"slotID":this.ITE_Name+"12","mapFace":"front","X":199,"Y":244},
                      {"slotID":this.ITE_Name+"13","mapFace":"front","X":0,"Y":293},
                      {"slotID":this.ITE_Name+"14","mapFace":"front","X":199,"Y":293} ] },
                    {"slotType":this.FAN_Name,"slotCount":10,"slotWidth":75,"slotHeight":63,"slotPositioning":[
                      {"slotID":this.FAN_Name+(FanIndex++),"mapFace":"back","X":71,"Y":0},
                      {"slotID":this.FAN_Name+(FanIndex++),"mapFace":"back","X":71,"Y":68},
                      {"slotID":this.FAN_Name+(FanIndex++),"mapFace":"back","X":71,"Y":136},
                      {"slotID":this.FAN_Name+(FanIndex++),"mapFace":"back","X":71,"Y":204},
                      {"slotID":this.FAN_Name+(FanIndex++),"mapFace":"back","X":71,"Y":272},
                      {"slotID":this.FAN_Name+(FanIndex++),"mapFace":"back","X":246,"Y":0},
                      {"slotID":this.FAN_Name+(FanIndex++),"mapFace":"back","X":246,"Y":68},
                      {"slotID":this.FAN_Name+(FanIndex++),"mapFace":"back","X":246,"Y":136},
                      {"slotID":this.FAN_Name+(FanIndex++),"mapFace":"back","X":246,"Y":204},
                      {"slotID":this.FAN_Name+(FanIndex++),"mapFace":"back","X":246,"Y":272} ] },
                    {"slotType":this.FAN2_Name,"slotCount":2,"slotWidth":88,"slotHeight":55,"slotPositioning":[
                      {"slotID":this.FAN2_Name+"0","mapFace":"back","X":152,"Y":0},
                      {"slotID":this.FAN2_Name+"1","mapFace":"back","X":152,"Y":281} ] },
                    {"slotType":this.PWR_Name,"slotCount":6,"slotWidth":40,"slotHeight":108,"slotPositioning":[
                      {"slotID":this.PWR_Name+(PwrIndex++),"mapFace":"back","X":26,"Y":0},
                      {"slotID":this.PWR_Name+(PwrIndex++),"mapFace":"back","X":26,"Y":114},
                      {"slotID":this.PWR_Name+(PwrIndex++),"mapFace":"back","X":26,"Y":229},
                      {"slotID":this.PWR_Name+(PwrIndex++),"mapFace":"back","X":327,"Y":0},
                      {"slotID":this.PWR_Name+(PwrIndex++),"mapFace":"back","X":327,"Y":114},
                      {"slotID":this.PWR_Name+(PwrIndex++),"mapFace":"back","X":327,"Y":229} ] },
                    {"slotType":this.MGT_Name,"slotCount":2,"slotWidth":21,"slotHeight":166,"slotPositioning":[
                      {"slotID":this.MGT_Name+(MgtIndex++),"mapFace":"back","X":0,"Y":0},
                      {"slotID":this.MGT_Name+(MgtIndex++),"mapFace":"back","X":373,"Y":171} ] },
                    {"slotType":this.IOM_Name,"slotCount":4,"slotWidth":16,"slotHeight":215,"slotPositioning":[
                      {"slotID":this.IOM_Name+(IOmIndex++),"mapFace":"back","X":152,"Y":60},
                      {"slotID":this.IOM_Name+(IOmIndex++),"mapFace":"back","X":175,"Y":60},
                      {"slotID":this.IOM_Name+(IOmIndex++),"mapFace":"back","X":199,"Y":60},
                      {"slotID":this.IOM_Name+(IOmIndex++),"mapFace":"back","X":223,"Y":60} ] },
                    {"slotType":this.DLM_Name,"slotCount":2,"slotWidth":21,"slotHeight":166,"slotPositioning":[
                      {"slotID":this.DLM_Name+(DLmIndex++),"mapFace":"back","X":373,"Y":0},
                      {"slotID":this.DLM_Name+(DLmIndex++),"mapFace":"back","X":0,"Y":171} ] }
                    ]
                };
              itmeUtils.CMTrace("LAYOUT", "vhCheck: " + this._viewHeight);
    } , */
    
    this._chassisSlotInformation6 = 
                  {"numberOfMapFaces":2, "mapFaces":[
                    {"mapName":"front","mapWidth":401,"mapHeight":343},
                    {"mapName":"back","mapWidth":401,"mapHeight":343} ],
                   "numberOfSlotTypes":8,"slots":[
                    {"slotType":this.ITE_Name,"slotCount":14,"slotWidth":194,"slotHeight":43,"slotPositioning":[
                      {"slotID":this.ITE_Name+"13","mapFace":"front","X":0,"Y":0},
                      {"slotID":this.ITE_Name+"14","mapFace":"front","X":199,"Y":0},
                      {"slotID":this.ITE_Name+"11","mapFace":"front","X":0,"Y":48},
                      {"slotID":this.ITE_Name+"12","mapFace":"front","X":199,"Y":48},
                      {"slotID":this.ITE_Name+"9","mapFace":"front","X":0,"Y":97},
                      {"slotID":this.ITE_Name+"10","mapFace":"front","X":199,"Y":97},
                      {"slotID":this.ITE_Name+"7","mapFace":"front","X":0,"Y":146},
                      {"slotID":this.ITE_Name+"8","mapFace":"front","X":199,"Y":146},
                      {"slotID":this.ITE_Name+"5","mapFace":"front","X":0,"Y":195},  
                      {"slotID":this.ITE_Name+"6","mapFace":"front","X":199,"Y":195},
                      {"slotID":this.ITE_Name+"3","mapFace":"front","X":0,"Y":244},
                      {"slotID":this.ITE_Name+"4","mapFace":"front","X":199,"Y":244},
                      {"slotID":this.ITE_Name+"1","mapFace":"front","X":0,"Y":293},
                      {"slotID":this.ITE_Name+"2","mapFace":"front","X":199,"Y":293} ] },
                    {"slotType":this.FAN_Name,"slotCount":8,"slotWidth":75,"slotHeight":69,"slotPositioning":[
                      {"slotID":this.FAN_Name+"9","mapFace":"back","X":72,"Y":39},    // y = 36 + (1x3) = 39
                      {"slotID":this.FAN_Name+"8","mapFace":"back","X":72,"Y":111},  // y = 39 + 69 + (1x3) = 111
                      {"slotID":this.FAN_Name+"7","mapFace":"back","X":72,"Y":202},  // y = 183 + 16 + (1x3) = 202
                      {"slotID":this.FAN_Name+"6","mapFace":"back","X":72,"Y":274},  // y = 202 + 69 + (1x3) = 274
                      {"slotID":this.FAN_Name+"4","mapFace":"back","X":272,"Y":39},
                      {"slotID":this.FAN_Name+"3","mapFace":"back","X":272,"Y":111},
                      {"slotID":this.FAN_Name+"2","mapFace":"back","X":272,"Y":202},
                      {"slotID":this.FAN_Name+"1","mapFace":"back","X":272,"Y":274} ] },
                    {"slotType":this.FAN2_Name,"slotCount":2,"slotWidth":75,"slotHeight":36,"slotPositioning":[
                      {"slotID":this.FAN_Name+"10","mapFace":"back","X":72,"Y":0},       //x = 43 + 23 + (2x3) = 72
                      {"slotID":this.FAN_Name+"5","mapFace":"back","X":272,"Y":0} ] },  //x = 72 + 75 + 26 + 18 + 43 + 23 (5x3) = 272
                    {"slotType":this.FANCTRL_Name,"slotCount":2,"slotWidth":75,"slotHeight":16,"slotPositioning":[
                      {"slotID":this.FANCTRL_Name+"2","mapFace":"back","X":72,"Y":183},       //y = 111 + 69 + (1x3) = 183
                      {"slotID":this.FANCTRL_Name+"1","mapFace":"back","X":272,"Y":183} ] },  
                    {"slotType":this.PWR_Name,"slotCount":6,"slotWidth":43,"slotHeight":112,"slotPositioning":[
                      {"slotID":this.PWR_Name+"6","mapFace":"back","X":0,"Y":0},       // y = 0
                      {"slotID":this.PWR_Name+"5","mapFace":"back","X":0,"Y":115},     // y = 114 + (1x3) = 117
                      {"slotID":this.PWR_Name+"4","mapFace":"back","X":0,"Y":230},     // y = 117 + 114 + (1x3) = 234
                      {"slotID":this.PWR_Name+"3","mapFace":"back","X":200,"Y":0},     //x = 72 + 75 + 26 + 18 + (3x3) = 200
                      {"slotID":this.PWR_Name+"2","mapFace":"back","X":200,"Y":115},
                      {"slotID":this.PWR_Name+"1","mapFace":"back","X":200,"Y":230} ] },
                    {"slotType":this.SPC1_Name,"slotCount":1,"slotWidth":20,"slotHeight":343,"slotPositioning":[
                      {"slotID":this.SPC1_Name+"0","mapFace":"back","X":179,"Y":0} ] }, //x = 150 + 26 + (1x3) = 179  
                    {"slotType":this.MGT_Name,"slotCount":2,"slotWidth":18,"slotHeight":165,"slotPositioning":[
                      {"slotID":this.MGT_Name+"2","mapFace":"back","X":379,"Y":0},    //x = 350 + 26 + (1x3) = 379
                      {"slotID":this.MGT_Name+"1","mapFace":"back","X":379,"Y":179} ] },   //y = 176 + (1x3) = 179
                    {"slotType":this.IOM_Name,"slotCount":4,"slotWidth":23,"slotHeight":343,"slotPositioning":[
                      {"slotID":this.IOM_Name+1,"mapFace":"back","X":46,"Y":0},      // x = 43 + (1x3) = 46
                      {"slotID":this.IOM_Name+3,"mapFace":"back","X":150,"Y":0},    // x = 72 + 75 + (1x3) = 150
                      {"slotID":this.IOM_Name+2,"mapFace":"back","X":246,"Y":0},      // x = 200 + 43 + (1x3) = 246
                      {"slotID":this.IOM_Name+4,"mapFace":"back","X":350,"Y":0} ] }, // x = 272 + 75 + (1x3) = 350
                    /*{"slotType":this.DLM_Name,"slotCount":2,"slotWidth":26,"slotHeight":343,"slotPositioning":[
                      {"slotID":this.DLM_Name+(DLmIndex++),"mapFace":"back","X":150,"Y":0},   // x = 72 + 75 + (1x3) = 150
                      {"slotID":this.DLM_Name+(DLmIndex++),"mapFace":"back","X":350,"Y":0} ] },   // x = 272 + 75 + (1x3) = 350
                    /*{"slotType":this.DLM_Name,"slotCount":2,"slotWidth":21,"slotHeight":166,"slotPositioning":[
                      {"slotID":this.DLM_Name+(DLmIndex++),"mapFace":"back","X":373,"Y":0},
                      {"slotID":this.DLM_Name+(DLmIndex++),"mapFace":"back","X":0,"Y":171} ] }*/
                    ]
                };
    itmeUtils.CMTrace("LAYOUT", "vhCheck: " + this._viewHeight);
    } ,

    // PUBLIC
    setDimensionsBasedOnNode: function(domNode)
    {
      itmeUtils.CMTrace("LAYOUT", "setDimensionsBasedOnNode BEGIN");
      this._containingDomNode = domNode;
      // - Forced OVERRIDES - 
      domNode.style.width = this._viewWidth + "px"; /*896 822*/                     // test only
      domNode.style.height = this._viewHeight + "px"; /*422 457 442 */           // test only
      // end forced overrides
      
      var contentBox = dojo.contentBox(domNode);
      //TODO: do we need this? it's causing gray space problems, commented it out (Alex)
      //this._viewWidth = contentBox.w;
      //this._viewHeight = contentBox.h;

      itmeUtils.CMTrace("LAYOUT", "  vwCheck: " + this._viewWidth);
      itmeUtils.CMTrace("LAYOUT", "  vhCheck: " + this._viewHeight);
      itmeUtils.CMTrace("LAYOUT", "setDimensionsBasedOnNode END");
    },

    _toggleWaitingPanel: function(isShown, waitingString) 
    {
      if ( ! isShown )
      {
        if ( dojo.byId("hardwareViewWaitingPane"))
          dojo.destroy("hardwareViewWaitingPane");
      }
      else
      {
        if ( ! dojo.byId("hardwareViewWaitingPane"))
        { itmeUtils.createElement("hardwareViewWaitingPane",
                                  this._chassisMapFaceElements[0],
                                  { styleClass: "refreshPendingDiv", 
                                    style: { "position":"absolute", "top":"20px", "left":"20px"},
                                    innerHTML: this.IMAGES.buildIconImageTag("Processing", "", 22) + " " + waitingString } );
        }
      }
    },
    
    // PROTECTED
    _buildChassisMapHTML: function()
    {
      itmeUtils.CMTrace("LAYOUT", "buildChassisMapHTML BEGIN");
      itmeUtils.CMTrace("LAYOUT", "  view Width: " + this._viewWidth);
      itmeUtils.CMTrace("LAYOUT", "  view Height: " + this._viewHeight);
      
      // set the layout to use
      this._chassisLayoutInformation = this._chassisSlotInformation6;
      
      // get the parent element to which we will append the nameplate and chassis face elements
      var chassisParentElement = dojo.byId(this._chassisMapParentDOMNodeID);
      var contentBox = dojo.contentBox(chassisParentElement);
      itmeUtils.CMTrace("LAYOUT", "  parent Width: " + contentBox.w);
      itmeUtils.CMTrace("LAYOUT", "  parent Height: " + contentBox.h);
      dojo.contentBox(chassisParentElement, {w: this._viewWidth, h: this._viewHeight});
      contentBox = dojo.contentBox(chassisParentElement);
      itmeUtils.CMTrace("LAYOUT", "  parent Width2: " + contentBox.w);
      itmeUtils.CMTrace("LAYOUT", "  parent Height2: " + contentBox.h);      

      dojo.attr(chassisParentElement, "class", "ChassisFrame" + ((dojo.isIE) ? " IECSS" : ""));
      
      // append child elements
      //this._appendChassisNameDivElement(chassisParentElement);
      for ( var i = 0; i < this._chassisLayoutInformation.numberOfMapFaces; i++)
      {
        this._appendChassisFaceDivElement(chassisParentElement, 
                                          this._chassisLayoutInformation.mapFaces[i].mapName,
                                          this._chassisLayoutInformation.mapFaces[i].mapWidth,
                                          this._chassisLayoutInformation.mapFaces[i].mapHeight ); 
      }
      this._appendChassisObjectsDivElement(this._chassisMapFaceElements["front"]);
      this._appendChassisOverlayDivElement(chassisParentElement);
    
      // scale the elements to fit the view frame
      var scale = this._getFacesToFrameRatio(this._chassisLayoutInformation);
      this._reSizeChassisMapFacesToScale(scale);
      
      // build the chassis component layout from the layout data
      this._buildChassisMapFromData(chassisParentElement, scale);
      
      if ( this._resizeEnabled === true )
        dojo.connect(window, "onresize", this, this._onFrameResize);
      
      itmeUtils.CMTrace("LAYOUT", "buildChassisMapHTML END");
    },

    /*// public
    setVisible: function(visibility)
    {
      itmeUtils.CMTrace("LAYOUT", "setVisible ("+visibility+")");
      
      var vizLabel = "block";
      if ( visibility !== true)
        vizLabel = "none";
      
      this._chassisNameElement.style.display = vizLabel;
      for (var i = 0; i < this._numFaceElements; i++)
        this._chassisMapFaceElements[i].style.display = "block";
    },*/

    // private
    _appendChassisOverlayDivElement: function(chassisParentElement)
    { 
      this._chassisOverlayElement = itmeUtils.createElement("chassisOverlay",
                                      chassisParentElement,
                                      { styleClass: "ChassisOverlayFrame soria",
                                        style: {  "position": "relative", // styleHash
                                                  "left": "0px",
                                                  //"top": "0px",
                                                  "float": "left",
                                                  "height": this._filterBarHeight + "px", //75
                                                  "width": this._viewWidth,
                                                  "display": "block"} } );
    },
    
    // private
    _appendChassisNameDivElement: function(chassisParentElement)
    {
      this._chassisNameElement = itmeUtils.createElement("chassisName",
                                    chassisParentElement,
                                    { styleClass: "ChassisHeader",
                                      style: {  "position": "relative",
                                                "left": "0px",
                                                "float": "left",
                                                "height": "20px",
                                                "display": "block"} });

      this._chassisNameElement.style.width = this._viewWidth - this._getNodeFluffWidth(this._chassisNameElement) ;//- 82;
      //itmeUtils.CMTrace("LAYOUT", "sanityCheck: " + this._chassisNameElement.style.width + " , fluff:" + this._getNodeFluffWidth(this._chassisNameElement));
    },

    // private
    _appendChassisFaceDivElement: function (chassisParentElement, faceName, width, height)
    {
      itmeUtils.CMTrace("LAYOUT", "building face ("+faceName+") : width will be: " + width + " +37");
      //var imgPath = this.IMAGES.getImage("ChassisFront");
      //if ( faceName == "back" )
      //  imgPath = this.IMAGES.getImage("ChassisBack");
      this._chassisMapFaceElements[this._numFaceElements++] = itmeUtils.createElement(
              "chassis" + faceName, 
              chassisParentElement,
              { styleClass: "ChassisFace ChassisFace"+faceName,
                style: {  "width":(width+37) +"px", 
                          "height":(height+38)+"px" 
                          /*"backgroundImage": "url('"+imgPath+"')"*/} } );

      // also index the dom element for the faces by name
      this._chassisMapFaceElements[faceName] = dojo.byId("chassis" + faceName);
      itmeUtils.CMTrace("LAYOUT", "resulting width is ... " + this._chassisMapFaceElements[faceName].style.width);
    },
    
    // private : 
    _appendChassisObjectsDivElement: function(chassisFaceElement)
    {
      itmeUtils.CMTrace("LAYOUT", "building chassis object div " + chassisFaceElement.style.width);
      this._chassisNameElement = itmeUtils.createElement(
              "chassisObjectDiv",
              chassisFaceElement,
              { styleClass: "ChassisComponent", 
                style: {  "position":"absolute", 
                          "left":"0px", 
                          "top":"0px", 
                          "width":chassisFaceElement.style.width, 
                          "height":chassisFaceElement.style.height, 
                          "display":"block"} } );

      // also index the dom element for the faces by name
      this._chassisNameElement = dojo.byId("chassisObjectDiv");
      this._chassisNameElement.constraint = 16;
      itmeUtils.CMTrace("LAYOUT", "resulting width is ... " + this._chassisNameElement.style.width);


      itmeUtils.createElement(
              "chassisInternalBackground_", 
              chassisFaceElement,
              { styleClass: "ChassisFaceInternalBackground", 
                style: {  "position":"absolute", 
                          "top":"19px",
                          "left":"19px",
                          "width":parseInt(chassisFaceElement.style.width)-38 +"px", 
                          "height":parseInt(chassisFaceElement.style.height)-38+"px", 
                          "display":"block"} } );
    },

    // private : fluff is defined as the total pixels of the margin & border for the dimension
    _getNodeFluffWidth: function(node)
    {
      if (node.fluffW) 
        return node.fluffW;
      
      this._calculateAndSetNodeFluff(node);
      return node.fluffW;
    },
    
    // private : fluff is defined as the total pixels of the margin & border for the dimension
    _getNodeFluffHeight: function(node)
    {
      if (node.fluffH) 
        return node.fluffH;
      
      this._calculateAndSetNodeFluff(node);
      return node.fluffH;
    },
    
    // private
    _calculateAndSetNodeFluff: function(node)
    {
      var contentBox = dojo.contentBox(node); // matches defined sizes on first load
      var marginBox = dojo.marginBox(node);
      node.fluffW = (marginBox.w - contentBox.w);
      node.fluffH = (marginBox.h - contentBox.h);
    },
    
    // private
    _buildChassisMapFromData: function (chassisParentElement, scaleFactor)
    {
      for (var i = 0; i < this._chassisLayoutInformation.numberOfSlotTypes; i++) {
        if (!this._chassisLayoutInformation.slots[i]) 
          alert("Chassis Slot " + (i + 1) + " information is missing");
        else {
          for (var j = 0; j < this._chassisLayoutInformation.slots[i].slotCount; j++) {
            if (!this._chassisLayoutInformation.slots[i].slotPositioning[j]) 
              alert("Chassis Slot Position " + (j + 1) + " of slot type " + this._chassisLayoutInformation.slots[i].slotType + " is missing");
            else {
              var newElement = itmeUtils.createElement(
                        this._chassisLayoutInformation.slots[i].slotPositioning[j].slotID, 
                        this._chassisMapFaceElements[this._chassisLayoutInformation.slots[i].slotPositioning[j].mapFace],
                        { styleClass: "Component EmptySlot",
                          style: {  "position": "absolute",
                                    "width": parseInt(this._chassisLayoutInformation.slots[i].slotWidth*scaleFactor) + "px",
                                    "height": parseInt(this._chassisLayoutInformation.slots[i].slotHeight*scaleFactor) + "px",
                                    "left": (parseInt(this._chassisLayoutInformation.slots[i].slotPositioning[j].X * scaleFactor) +18)+ "px",
                                    "top": (parseInt(this._chassisLayoutInformation.slots[i].slotPositioning[j].Y * scaleFactor) +18)+ "px",
                                    "overflow": "hidden",
                                    "text-overflow": "ellipsis" } } );
                        
              newElement.constraint = this._determineElementConstraint(newElement);          
              // CHEAT:
              var imageStr = null;
              switch (this._chassisLayoutInformation.slots[i].slotType) {
                case this.PWR_Name:
                  imageStr = this.IMAGES.getImage("PowerUnitEmpty");
                  break;
                case this.FAN_Name:
                  imageStr = this.IMAGES.getImage("FanFillerLarge");
                  break;
                case this.FAN2_Name:
                  imageStr = this.IMAGES.getImage("FanFillerSmall");
                  break;
                case this.FANCTRL_Name:
                  imageStr = this.IMAGES.getImage("FanControlFiller");
                  break;
                case this.DLM_Name:
                  imageStr = this.IMAGES.getImage("SwitchFiller");
                  break;
                case this.MGT_Name:
                  imageStr = this.IMAGES.getImage("CMMFiller");
                  break;
                case this.IOM_Name:
                  imageStr = this.IMAGES.getImage("SwitchFiller");
                  break;
                case this.ITE_Name:
                  imageStr = this.IMAGES.getImage("EmptyBladeSlot");
                  break;
                case this.SPC1_Name: 
                  imageStr = this.IMAGES.getImage("TallSpacer");
                  break;
              }
              if (imageStr)
                newElement.innerHTML = "<img id='" + newElement.id + "_IMG' src='" + imageStr + "' width='" + newElement.style.width + "' height='" + newElement.style.height + "'>";
              // end CHEAT
              
            }
          }
        }
      }
    },

    // TYPE: RENDER
    _determineElementConstraint: function(element) {
      var cBox = dojo.contentBox(element);
      if ( cBox.w < cBox.h )
        return cBox.w - 2;
      return cBox.h - 2;
    },

    // private
    _getFacesToFrameRatio: function()
    {
      itmeUtils.CMTrace("LAYOUT", "_getFacesToFrameRatio");
      itmeUtils.initializeTimer("FaceToFrameRatio"); // for performance tracing
      
      var faceSizeInfo = this._calculateFacesInfo();
      
      itmeUtils.traceTimeDelta("LAYOUT", "Time for Faces Calculation", true);
      
      // HEIGHT - get name element information to subtract from usable vertical space 
      //var nameElementMarginBox = dojo.marginBox(this._chassisNameElement);
      // vertical size for the map faces = ChassisFrame - nameElement.h - fluffHeight (=margin&border of faces);
      var actualViewHeightForChassisFaces = this._viewHeight - /*nameElementMarginBox.h -*/ faceSizeInfo.fluffH;
      itmeUtils.CMTrace("LAYOUT", "Total frame height: "+ this._viewHeight + " - nameElement height: "+ /*nameElementMarginBox.h +*/ " - fluffHeight: " + faceSizeInfo.fluffH);
      itmeUtils.CMTrace("LAYOUT", "  = Actual View Height: " + actualViewHeightForChassisFaces);

      itmeUtils.traceTimeDelta("LAYOUT", "Time for Height Calculation", true);

      // WIDTH -       
      var actualViewWidthForChassisFaces = this._viewWidth - faceSizeInfo.fluffW;
      itmeUtils.CMTrace("LAYOUT", "view width: " + this._viewWidth + " , fluffW: " + faceSizeInfo.fluffW);
      if ( dojo.isIE)  // HACK. For some reason IE math doesn't add up the same... +12 seems to fix it.. not sure why yet.
        actualViewWidthForChassisFaces -= 12;
      itmeUtils.CMTrace("LAYOUT", "Total frame width: "+ this._viewWidth + " - fluffWidth: " + faceSizeInfo.fluffW);
      itmeUtils.CMTrace("LAYOUT", "  = Actual View width: "+ actualViewWidthForChassisFaces);

      itmeUtils.traceTimeDelta("LAYOUT", "Time for Width Calculation", true);
      
      var widthRatio = (actualViewWidthForChassisFaces) / faceSizeInfo.maxW; // had = (actualViewWidthForChassisFaces - 82) / faceSizeInfo.maxW;
      var heightRatio = (actualViewHeightForChassisFaces - this._filterBarHeight) / faceSizeInfo.maxH; 
      itmeUtils.CMTrace("LAYOUT", "target view size: w:"+this._viewWidth + " ,h:"+this._viewHeight);
      itmeUtils.CMTrace("LAYOUT", "target view size less fluff: w:"+actualViewWidthForChassisFaces + " ,h:"+actualViewHeightForChassisFaces);
      itmeUtils.CMTrace("LAYOUT", "ratio to target view size: w:"+widthRatio + " ,h:"+heightRatio);
      // take the smaller of the 2
      var usingRatio = Math.min(widthRatio, heightRatio);
      itmeUtils.CMTrace("LAYOUT", "using ratio: "+usingRatio);
      
      itmeUtils.traceTimeDelta("LAYOUT", "Final Processing", true);

      return 1;
      //return usingRatio;
    },

    // private
    // Iterates through the map faces defined and calculates the following
    // total size .totalW  .totalH  //
    // max size .maxW   .maxH
    _faceSizeInformation: null, // private var to cache results of the below
    _calculateFacesInfo: function()
    {
      if (this._faceSizeInformation)
        return this._faceSizeInformation;
        
      var sizes = [];
      sizes.maxW = sizes.maxH = sizes.fluffW = sizes.fluffH = sizes.totalW = sizes.totalH = 0;
      for ( var i = 0; i < this._chassisLayoutInformation.numberOfMapFaces; i++)
      {
        var contentBox = dojo.contentBox(this._chassisMapFaceElements[i]); // matches defined sizes on first load
        var marginBox = dojo.marginBox(this._chassisMapFaceElements[i]);

        sizes.maxW += this._chassisLayoutInformation.mapFaces[i].mapWidth; 
        sizes.fluffW += (marginBox.w - contentBox.w); // including border
        sizes.totalW += this._chassisLayoutInformation.mapFaces[i].mapWidth;
        
        if (this._chassisLayoutInformation.mapFaces[i].mapHeight > sizes.maxH) {
          sizes.maxH = this._chassisLayoutInformation.mapFaces[i].mapHeight;
          sizes.fluffH += (marginBox.h - contentBox.h); // including border
        }
        sizes.totalH += this._chassisLayoutInformation.mapFaces[i].mapHeight;
        
        itmeUtils.CMTrace("LAYOUT", "Face[" + i + "]: --------------------------");
        itmeUtils.CMTrace("LAYOUT", "   max: w:" + sizes.maxW + " ,h:" + sizes.maxH);
        itmeUtils.CMTrace("LAYOUT", "   face fluff: w:" + (marginBox.w - contentBox.w) + " , h:" + (marginBox.h - contentBox.h));
        itmeUtils.CMTrace("LAYOUT", "   face marginBox:  mb.w:" + marginBox.w + " , mb.h:" + marginBox.h);
        itmeUtils.CMTrace("LAYOUT", "   face contentBox: cb.w:" + contentBox.w + " , cb.h:" + contentBox.h);
      } 
      itmeUtils.CMTrace("LAYOUT", "Sum          : --------------------------");
      itmeUtils.CMTrace("LAYOUT", "   sizes: .maxW:" + sizes.maxW + " , maxH:" + sizes.maxH);
      itmeUtils.CMTrace("LAYOUT", "   sizes: .fluffW:" + sizes.fluffW + " , fluffH:" + sizes.fluffH);
      itmeUtils.CMTrace("LAYOUT", "   sizes: .totalW:" + sizes.totalW + " , totalH:" + sizes.totalH);
      itmeUtils.CMTrace("LAYOUT", "             : --------------------------");
      this._faceSizeInformation = sizes;
      return this._faceSizeInformation;
    },
    
    // private
    _reSizeChassisMapFacesToScale: function(scaleFactor)
    {
      for (var i = 0; i < this._chassisLayoutInformation.numberOfMapFaces; i++) {
        var computedStyle = dojo.style(this._chassisMapFaceElements[i]);
        var newWidth = parseInt(computedStyle.width) * scaleFactor;
        var newHeight = parseInt(computedStyle.height) * scaleFactor;
        itmeUtils.CMTrace("LAYOUT", "width delta: " + computedStyle.width + " -> " + newWidth);
        itmeUtils.CMTrace("LAYOUT", "height delta: " + computedStyle.height + " -> " + newHeight);
        this._chassisMapFaceElements[i].style.width = parseInt(newWidth);
        this._chassisMapFaceElements[i].style.height = parseInt(newHeight);
      }
    },
    
    // private
    _onFrameResize: function()
    {
      itmeUtils.CMTrace("LAYOUT", "RESIZE EVENT CAPTURED");
      if(this._resizingTimeoutDelay !== false)
        clearTimeout(this._resizingTimeoutDelay);
      this._resizingTimeoutDelay = setTimeout(dojo.hitch(this, this._resize), 500); //200 is time in miliseconds
    },
    
    // private
    _resize: function()
    {
      this._updateViewDimensions();
      var scaleFactor = this._getFacesToFrameRatio();
      itmeUtils.CMTrace("LAYOUT", " - Faces to Frame Ratio now: " + scaleFactor);
      
      // trace initial object sizs
      this.__traceObjectSizesAndPositioning();
      
      // RESIZE BEGIN
      this._resizingTimeoutDelay = false;
      var chassisLayoutInformation = this._chassisLayoutInformation;
      
      // Name element width = view width - name element fluff
      //this._chassisNameElement.style.width = this._viewWidth - this._getNodeFluffWidth(this._chassisNameElement);
      
      // Face elements size = defined size * scale factor
      for (var i = 0; i < this._numFaceElements; i++) {
        this._chassisMapFaceElements[i].style.width = parseInt( this._chassisLayoutInformation.mapFaces[i].mapWidth*scaleFactor);
        this._chassisMapFaceElements[i].style.height = parseInt( this._chassisLayoutInformation.mapFaces[i].mapHeight*scaleFactor);
      }
      
      // Element sizing = defined size * scale factor.  Additionally offsets are multiplied by the scale factor
      for (i = 0; i < chassisLayoutInformation.numberOfSlotTypes; i++) {
        if (!chassisLayoutInformation.slots[i]) 
          alert("Chassis Slot " + (i + 1) + " information is missing");
        else {
          
          for (var j = 0; j < chassisLayoutInformation.slots[i].slotCount; j++) {
            if (!chassisLayoutInformation.slots[i].slotPositioning[j]) 
              alert("Chassis Slot Position " + (j + 1) + " of slot type " + chassisLayoutInformation.slots[i].slotType + " is missing");
            else {
              
              // resize the element
              element = dojo.byId(chassisLayoutInformation.slots[i].slotPositioning[j].slotID);
              dojo.attr(element, "style", { "position": "absolute",
                                            "width": parseInt(chassisLayoutInformation.slots[i].slotWidth*scaleFactor) + "px",
                                            "height": parseInt(chassisLayoutInformation.slots[i].slotHeight*scaleFactor) + "px",
                                            "left": parseInt(chassisLayoutInformation.slots[i].slotPositioning[j].X * scaleFactor) + "px",
                                            "top": parseInt(chassisLayoutInformation.slots[i].slotPositioning[j].Y * scaleFactor) + "px",
                                            "overflow": "hidden",
                                            "text-overflow": "ellipsis" });
              
              // update the element constraint value
              element.constraint = this._determineElementConstraint(element);
              
              for (var sIndex in element.childNodes) {
                if (element.childNodes[sIndex].id) { // if this is a named node
                  element.childNodes[sIndex].style.width = parseInt(chassisLayoutInformation.slots[i].slotWidth*scaleFactor) + "px";
                  element.childNodes[sIndex].style.height = parseInt(chassisLayoutInformation.slots[i].slotHeight*scaleFactor) + "px";
                }
              }
              // if there is an image associated with the slot, resize that as well
              //if (dojo.byId(chassisLayoutInformation.slots[i].slotPositioning[j].slotID + "_IMG")) {
              //  element = dojo.byId(chassisLayoutInformation.slots[i].slotPositioning[j].slotID + "_IMG");
              //  element.style.width = parseInt(chassisLayoutInformation.slots[i].slotWidth*scaleFactor) + "px";
              //  element.style.height = parseInt(chassisLayoutInformation.slots[i].slotHeight*scaleFactor) + "px";
              //}
              
            }
          }
        }
      }
      
      // trace completed resizing object sizes
      this.__traceObjectSizesAndPositioning();
      
    },
    
    __traceObjectSizesAndPositioning: function() {
      itmeUtils.CMTrace("LAYOUT", "");
    },
    
    // private
    // gets the present container node size and sets our internal view dimensions we use for processing from it.
    _updateViewDimensions: function(){
      if (this._containingDomNode) { // can only get new dimensions if we were given a DOM node to base sizing off of.
        itmeUtils.CMTrace("LAYOUT", " - previous view dimensions: w: " + this._viewWidth + " , h: " + this._viewHeight);
        var contentBox = dojo.contentBox(this._containingDomNode);
        this._viewWidth = contentBox.w;
        this._viewHeight = contentBox.h;
        itmeUtils.CMTrace("LAYOUT", " - parent node id: " + this._containingDomNode.id);
        itmeUtils.CMTrace("LAYOUT", " - getting new view dimensions: w: " + this._viewWidth + " , h: " + this._viewHeight);
      }
    },
    
    // protected
    // for each SLOT of SLOTTYPE, merge those div elements (remove and rebuild the div tags)
    mergeSlots: function(slotId, slotType, slotsOccupied) {
      var elementArray = [];
      var topsMatch = true;
      var leftsMatch = true;
      var topMost = 0; var leftMost = 0; var rightMost = 0; var bottomMost = 0;
      var parentNode = null;
      for (var i = 0; i < slotsOccupied.length; i++)
      {
        elementArray[i] = dojo.byId(slotType+slotsOccupied[i]);
        
        if ( !parentNode )
          parentNode = elementArray[i].parentNode;  

        var right = parseInt(elementArray[i].style.left)+parseInt(elementArray[i].style.width);
        var bottom = parseInt(elementArray[i].style.top)+parseInt(elementArray[i].style.height);
        if ( topsMatch && ( i > 0 ) )
        {
          if ( elementArray[i].style.top != elementArray[i-1].style.top )
            topsMatch = false;
        }
        if ( leftsMatch && ( i > 0 ) )
        {
          if ( elementArray[i].style.left != elementArray[i-1].style.left )
            leftsMatch = false;
        }
        if ( i == 0 ) {
          topMost = parseInt(elementArray[i].style.top);
          leftMost = parseInt(elementArray[i].style.left);
          rightMost = right;
          bottomMost = bottom;
        }
        else {
          if ( parseInt(elementArray[i].style.top) < topMost )
            topMost = parseInt(elementArray[i].style.top);
          if ( parseInt(elementArray[i].style.left) < leftMost )
            leftMost = parseInt(elementArray[i].style.left);
          if ( right > rightMost )
            rightMost = right;
          if ( bottom > bottomMost )
            bottomMost = bottom;
        }
        
        //elementArray[i].style.backgroundImage = "none";
        parentNode.removeChild(elementArray[i]);
      }
      
      var newElement = itmeUtils.createElement(
                        slotType+slotId,
                        parentNode,
                        { styleClass: "Component EmptySlot", 
                          style: {  "position": "absolute",
                                    "width": (rightMost - leftMost) + "px",
                                    "height": (bottomMost - topMost) + "px",
                                    "left": leftMost+ "px",
                                    "top": topMost+ "px",
                                    "overflow": "hidden",
                                    "text-overflow": "ellipsis" } } );
                        
      newElement.constraint = this._determineElementConstraint(newElement);        
      return newElement;
    }


});

}
