/*
	Copyright (c) 2004-2010, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource["itme.DojoMenuOverride"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["itme.DojoMenuOverride"] = true;
dojo.provide("itme.DojoMenuOverride");

dojo.require("dijit.Menu");
// this class differs from the dojo menu widget in one way.  
//  IF the menu item that receives the click is a 'CheckedMenuItem' it will NOT close the menu
//  Deviation from dojo called out below with DEVIATION
//  Confirmed to work with dojo 1.4 & 1.5
dojo.declare("itme.DojoMenuOverride", dijit.Menu,
 {
    onItemClick: function(/*dijit._Widget*/ item, /*Event*/ evt){
    // summary:
    //    Handle clicks on an item.
    // tags:
    //    private
    

    // this can't be done in _onFocus since the _onFocus events occurs asynchronously
    if(typeof this.isShowingNow == 'undefined'){ // non-popup menu
      this._markActive();
    }

    this.focusChild(item);

    if(item.disabled){ return false; }

    if(item.popup){
      this._openPopup();
    }else{
      // before calling user defined handler, close hierarchy of menus
      // and restore focus to place it was when menu was opened
      // BEGIN DEVIATION : Only call onExecute (closes the menu) if not a checkedMenuItem  
      if ( item.declaredClass != "dijit.CheckedMenuItem" )
      // END DEVIATION
       this.onExecute();

      // user defined handler for click
      item.onClick(evt);
    }
  }

 });

}
