/*
	Copyright (c) 2004-2010, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource["itme.finder.FinderBaseDataStore"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["itme.finder.FinderBaseDataStore"] = true;
dojo.provide("itme.finder.FinderBaseDataStore");

dojo.require("itme.finder.TaskCategory");
dojo.require("dojox.data.AndOrReadStore"); 

dojo.declare("itme.finder.FinderBaseDataStore", null, {
    _dataStore: null,
  	_type: null,  
  	_categories: null,    
    constructor: function(type, domId){  
    	this._type = type;
    }, 
    getCategories : function() {
    	return this._categories;
    },
    populateCategoriesWithSelectedItems: function(myitems) {		
 		var i = 0;
 		for(i = 0; i < myitems.length; i++) { 			
 			var item = myitems[i];
 			this._categories[item.categoryIdx].addSelected(item.objectIdx);
 		} 	
 		phxTrace('populatedCategories for ' + i + ' items');
	},
	populateSearchResultItem: function(resultItemDomElement, finderObj, extraClass, notClickable) {
		var classname = 'SelectableCommonAction';
		if(notClickable) {
			classname = 'notSelectableCommonAction';
		}
		if(extraClass) classname = extraClass + " " + classname;		
		dojo.addClass(resultItemDomElement, classname);
		if(notClickable != true) {
 			dojo.connect(dojo.byId(resultItemDomElement), "onmouseover", function() { this.className=classname + "Hover"; });        
        	dojo.connect(dojo.byId(resultItemDomElement), "onmouseout", function() { this.className=classname; });
        	dojo.connect(dojo.byId(resultItemDomElement), "onclick", dojo.hitch(finderObj, finderObj.doClick));		
        }
	},
	createCategoryHTMLElements: function(numberOfResults, finderObj, moreId, moreText, notClickable) {
		var maxNumberOfResults = 32;
		var numberOfItemsCurrentlyShowing = 0;
		var lastCategory = false;
		var i = 1;
		for(i = 1; i < this._categories.length; i++) {
			if(this._categories[i]) {				
 				var count = this._categories[i].getSelectedCount();
 				if(count == 0) {
 					if(lastCategory == true) {
 						break;
 					}
 					continue;
 				} 					
 				if(maxNumberOfResults <= 0) {
 					var moreActionsDiv = dojo.create("div", {id: moreId, 
 					innerHTML:'<BR/><span> ... ' + ' ' + moreText + '</span>'}, dojo.byId(finderObj._finderIdPrefix + this._type + "_containerDiv"));      
 					this.populateSearchResultItem(moreActionsDiv, finderObj, 'finderMoreTasks', notClickable); 
 										
 					break;
 				}
 				var j;
 				//create category section 				
 				//phxTrace('creating category: ' + this._categories[i].getCategory());
 				var sectionDomNode = dojo.create("div", {id: "categorySection"+ this._type + "#_"+ i},  dojo.byId(finderObj._finderIdPrefix + this._type+"_containerDiv"));
              	var sectionTitleDomNode = objHighlightSearchStr(sectionDomNode, dijit.byId(finderObj._finderIdPrefix + "searchBox").attr("value"), this._categories[i].getCategory(), 'true'); 
                if(this._type == 'resources') {
                //  Figure out what to do for selecting a whole group of resources of same type
                //  Problem when we have more than 1 chassis, what chassis map to launch?
                //	this.populateSearchResultItem(sectionDomNode, finderObj, sectionDomNode.className);
                //	sectionTitleDomNode.title = 'Select all resources of this type';
                
                /*var launchAllSpan = dojo.create("span", {
                	innerHTML: ' - Select all for:'}, 
                	sectionTitleDomNode);
				dojo.addClass(launchAllSpan, 'SelectableCommonAction');
 				dojo.connect(launchAllSpan, "onmouseover", function() { this.className="SelectableCommonActionHover"; });        
        		dojo.connect(launchAllSpan, "onmouseout", function() { this.className="SelectableCommonAction"; });
       
    		    var dropDown = dojo.create("select", {
                	name:  this._categories[i].getCategory()}, 
                	sectionTitleDomNode);
                var option1 = dojo.create("option", {
                	value: 'chassis1', selected:'selected', innerHTML: 'MyChassis1'}, 
                	dropDown);
                var option2 = dojo.create("option", {
                	value: 'chassis2', innerHTML: 'MyChassis2'}, 
                	dropDown);
    		   
    		    var tooltipDiv = dojo.create('div', {});
    			dojo.create('div', {innerHTML: 'Select all resources of this type for: '}, tooltipDiv);
   		 		dojo.create('div', {innerHTML: 'chassis 1'}, tooltipDiv);
   		 		dojo.create('div', {innerHTML: 'chassis 2'}, tooltipDiv);
       			var dlg = new dijit.Tooltip({showDelay:0, connectId: [sectionTitleDomNode], label: tooltipDiv.innerHTML});
    			*/
   		   					
   		   		}      	
                //dojo.addClass(sectionTitle, "categorySectionTitle");
 				for(j = 0; j < count; j++) {
 					if(maxNumberOfResults == 0) break; 					
 					var itemId = this._type + "#_" + this._categories[i].getSelectedId(j);
 					var itemDiv = dojo.create("div", {id: itemId}, "categorySection" +this._type+"#_"+ i);      
          			objHighlightSearchStr(itemDiv, dijit.byId(finderObj._finderIdPrefix + "searchBox").attr("value"), this._categories[i].getSelectedName(j)); 
                    this.populateSearchResultItem(itemId, finderObj);
                    maxNumberOfResults--;
                    numberOfItemsCurrentlyShowing++;
 				} 	
 				    	
 				maxNumberOfResults = maxNumberOfResults - 2;
 				if(lastCategory == true) {
 					break;
 				}		
 			} else {
 				i = -1;
 				lastCategory = true; 
 			}
 		}
	},
	clearSelection: function() {
		var i;
		for(i = 0; i < this._categories.length; i++) {
			if(this._categories[i]) {
				this._categories[i].clearSelection();
			} else {
				break;
			}
		}
	},
    populateItems : function(list) {
    	phxTrace('inpopulate');
    	this._categories = new Array(200);
    	if(list == null || list == "") {
    		return;
    	}
    	var itemsFromList = list.split('#_');
    	var size = itemsFromList.length;
    	var i = 0;
    	var items = new Array(size);
    	this._categories[0] = new itme.finder.TaskCategory("Uncategorized");
    	for(i = 0; i < itemsFromList.length; i++) {    	
    		var object = itemsFromList[i];
    		var attributes = object.split(';');
   			var catIdx = 0;
   			var objectIdx;
   			for(catIdx = 0; catIdx < this._categories.length; catIdx++) {
   				if(this._categories[catIdx]) {
   					if(this._categories[catIdx].getCategory() == attributes[2]) {
   						var tempcategory = this._categories[catIdx]
   						objectIdx = tempcategory.add(attributes[0], attributes[1]);  
    					break;  					
    				} 
    			} else {
    				this._categories[catIdx] = new itme.finder.TaskCategory(attributes[2]);
    				objectIdx = this._categories[catIdx].add(attributes[0], attributes[1]); 
    				break;    					
    			}
    		}    			
    		items[i] = {'id': attributes[0], 'name':attributes[1], 'category':attributes[2], 'categoryIdx':catIdx, 'objectIdx':objectIdx};
    	}    
    	phxTrace('parsed items, total: ' + i);	
    	var dataStore = { identifier: 'id', label: 'name', items: items };     
    	this._dataStore = new  dojox.data.AndOrReadStore({data:dataStore});       	
    	phxTrace(this._dataStore);	
    	
    }
});

}
