#
# Licensed Materials - Property of IBM
#
# OCO Source Materials
#
# (C) Copyright IBM Corp. 2011 All Rights Reserved
#
# The source code for this program is not published or other-
# wise divested of its trade secrets, irrespective of what has
# been deposited with the U.S. Copyright Office.
#

#!/bin/bash

#Get FSM version
verNum=$(cat /opt/ibm/director/lwi/runtime/itme/eclipse/plugins/isdvmi.version | grep 'version'  | cut -d "=" -f2- | cut -d "." -f1)
relNum=$(cat /opt/ibm/director/lwi/runtime/itme/eclipse/plugins/isdvmi.version | grep 'version'  | cut -d "=" -f2- | cut -d "." -f2)
packNum=$(cat /opt/ibm/director/lwi/runtime/itme/eclipse/plugins/isdvmi.version | grep 'version' | cut -d "=" -f2- | cut -d "." -f3)
buildNum=$(cat /opt/ibm/director/lwi/runtime/itme/eclipse/plugins/isdvmi.version | grep 'level'  | cut -d "=" -f2-)

#Edit outfile with new service.
host=$(hostname)
date=$(date)
outfile="/etc/opt/ibm/icc/slp.reg"
IPinput="/etc/opt/ibm/icc/lsnetcfg.out"
echo "#"$host": Creating file "$date"" > $outfile

#Using lsnetcfg -n to get IP addresses
echo "#calling lsnetcfg -n..." >> $outfile
/opt/ibm/director/vmi/bin/lsnetcfg -n > $IPinput 2>&1

#Get eth0 addresses
ipv4_eth0=$(cat $IPinput | grep ipv4addr_eth0 | cut -d ":" -f2 | cut -d " " -f2)
ipv6lla_eth0=$(cat $IPinput | grep ipv6addr_eth0 | cut -d ":" -f2- | cut -d "/" -f2 | cut -d "," -f2)
ipv6ula_eth0=$(cat $IPinput | grep ipv6addr_eth0 | cut -d ":" -f2- | cut -d "/" -f1 |  cut -d " " -f2)

function regServ () {
    
    echo "Executing regServ "$1"" 
    echo "service:management-hardware.IBM:flex-system-manager://"$1",en,65535" >> $outfile
    echo "Version="$verNum"" >> $outfile
    echo "Release="$relNum"" >> $outfile
    echo "Service Pack="$packNum"" >> $outfile
    echo "Buildlevel="$buildNum"" >> $outfile
    echo "" >> $outfile

}

#If address is not empty, then register it as a service 
#It's possible that ipv6 values might contain just the prefix-length, ignore in that case.
if [ -n "$ipv4_eth0" ]
then
    regServ "$ipv4_eth0"
else 
    echo "#ipv4_eth0 is empty" >> $outfile
fi

len1=$(expr length "$ipv6lla_eth0")
if [ $len1 -gt 2 ]
then
    regServ "$ipv6lla_eth0"
else 
    echo "#ipv6lla_eth0 is empty" >> $outfile
fi

len2=$(expr length "$ipv6ula_eth0")
if [ $len2 -gt 2 ]
then
    regServ "$ipv6ula_eth0"
else 
    echo "#ipv6ula_eth0 is empty" >> $outfile
fi

#Start SLPD to trigger static registration file.
/etc/init.d/paslpd restart

exit 0
